unit Cli_app;
interface

{$I options.pp}

uses
 Trace, Common, TV_box, App, Drivers, Views, Cli_FWin;

type
 TSRDBApp = object(TSApplication)
  FileWindow:PFilesWindow;
  constructor Init;
  destructor Done; virtual;
  function  GetPalette: PPalette; virtual;
  procedure InitMenuBar; virtual;
  procedure InitStatusLine; virtual;
  procedure Idle; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure UseFile;
  procedure DoAboutBox;
 end;

var
 SRDBApp: TSRDBApp;

procedure CliAction(Cmd:byte; var Buf:TNetBuf);

implementation

uses
 crt,
{ SPX_Def, } TCP_Clnt,
 Menu_cmd, Str_def,
 Cli_Info, Cli_proc, Cli_brs0, Cli_Data,
 Objects, Menus;

constructor TSRDBApp.Init;
 var Event:TEvent;
 begin
  inherited Init;
{
  New(SPXWin,Init); InsertWindow(SPXWin);
}
  New(PInfo,Init); InsertWindow(PInfo); FreshCounter;
  DisableCommands(TCommandSet(UseCmdSet+DesCmdSet));
  Event.What := evBroadcast;
  Event.Command := cmOpenDataMsg;
  Event.InfoPtr := nil;
  PutEvent(Event);
 end;
destructor TSRDBApp.Done;
 begin
  if Server<>Nil then begin 
   Dispose(Server,Done);
   Server:=Nil;
  end; 
  inherited Done;
 end;

const
  CSkeletColor =
        { Menu & Status line colors }{     Blue Window Colors      }
        #$71#$70#$78#$74#$4F#$46#$4E#$17#$1F#$1A#$31#$31#$1E#$71#$1F +
     {     Brown Window Colors      }{     Gray Window Colors      }
    #$67#$6F#$6A#$13#$13#$6E#$4E#$3F#$70#$7F#$7A#$13#$13#$70#$4E#$7E +
     {   Dialog boxes colors - gray, blue, cyan ( $20 for each )   }
    #$70#$7F#$7A#$13#$13#$70#$70#$7F#$7E#$20#$2B#$2F#$78#$2E#$70#$30 +
    #$3F#$3E#$1F#$2F#$1A#$20#$72#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$17#$1F#$1A#$71#$71#$1E#$17#$1F#$1E#$20#$2B#$2F#$78#$2E#$10#$30 +
    #$3F#$3E#$70#$2F#$7A#$20#$12#$31#$31#$30#$2F#$3E#$31#$13#$38#$00 +
    #$37#$3F#$3A#$13#$13#$3E#$30#$3F#$3E#$20#$2B#$2F#$78#$2E#$30#$70 +
    #$7F#$7E#$1F#$2F#$1A#$20#$32#$31#$71#$70#$2F#$7E#$71#$13#$38#$00;

function TSRDBApp.GetPalette: PPalette;
 const
  P: array[apColor..apMonochrome] of string[Length(CAppColor)] =
    (CSkeletColor, CAppBlackWhite, CAppMonochrome);
 begin
  GetPalette := @P[AppPalette];
 end;

{$IFDEF Cyr} {$I cli_app0.pp} {$ELSE} {$I cli_app1.pp} {$ENDIF}

procedure TSRDBApp.UseFile;
 var FId:byte;
 begin
  SetUserMode;
  FId:=FileWindow^.WinCursor;
  if DFArr[FId]^.Fields^.Length>0
   then InsertWindow(New(PStdBrouse,Init(FId)))
   else ErrNum(esMissFields0);
 end;

procedure CliAction(Cmd:byte; var Buf:TNetBuf);
 var
  SrvState:TServerState absolute Buf;
  Head:TCliWinHead absolute Buf;
  TMR:TModifyRecord absolute Buf;
 begin case cmd of
  ncServerState:PInfo^.SrvState:=SrvState;
  ncLocProcAnswer:with Ports[Head.Port] do
   if (PWin<>Nil) and (Head.SesId=SesId)
    then PWin^.Answer(Head.PCmd,Buf[SizeOf(Head)]);
  ncModifyRecord:begin
    with TMR do case Mcase of
     NewRec:inc(DFArr[FileId]^.FilSize);
     EraseRec:dec(DFArr[FileId]^.FilSize);
    end;
    SRDBApp.FileWindow^.DrawView;
    Message(Application,evBroadcast,cmSetCursor,@Buf);
   end;
 end end;

function IdleLoop:boolean;
 var Cmd:byte; Buf:TNetBuf;
 begin
  IdleLoop:=false;
  if Server<>Nil then with Server^ do if Used
   then if NetListen(cmd,Buf)
    then begin
     CliAction(cmd,Buf); 
     IdleLoop:=True 
    end 
 end;

procedure TSRDBApp.Idle;
 begin
  inherited Idle;
  if IdleLoop then else begin
   Delay(30); { Leave processor resorcess }
   FreshCounter;
  end; 
 end;

procedure TSRDBApp.HandleEvent(var Event: TEvent);
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evBroadcast:case Event.Command of
    cmUseFile:UseFile;
    cmOpenDataMsg:Connect;
    else Exit;
   end;
   evCommand:case Event.Command of
    cmAbout:DoAboutBox;
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

end.