procedure TSRDBApp.InitMenuBar;
 var R: TRect;
 begin
  GetExtent(R); R.B.Y := R.A.Y + 1;
  MenuBar := New(PSMenuBar, Init(R, NewMenu(
    NewSubMenu('~1~ ', hcNoContext, NewMenu(
      NewItem('~1~ ','Enter',kbEnter,cmUse,  hcNoContext,
      NewItem('~2~ ',    'F4',kbF4,cmOrder,hcNoContext,
      NewItem('~3~ ',   'F5',kbF5,cmPart, hcNoContext,
      NewLine(
      NewItem('~4~ ','Alt-X',kbAltX,cmQuit,hcNoContext,
      nil)))))
      ),
    NewSubMenu('~2~ ',hcNoContext, NewMenu(
      NewItem('~1~  ','F1',kbF1,cmNewRec, hcNoContext,
      NewItem('~2~ ',  'F2',kbF2,cmEditRec,hcNoContext,
      NewItem('~3~ ', 'F8',kbF8,cmDupRec, hcNoContext,
      NewLine(
      NewItem('~4~ ','F3',kbF3,cmDelRec,hcNoContext,
      NewItem('~5~ ','F7',kbF7,cmMixRec,hcNoContext,
      NewLine(
      NewItem('~6~ ','F6',kbF6,cmRecLinks,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~3~ ',hcNoContext, NewMenu(
      NewItem('~1~   ', '',kbNoKey,cmFullSel, hcNoContext,
      NewItem('~2~   ',   'F10',kbF10,cmQuerySel,hcNoContext,
      NewItem('~3~  ()','Shift-F6',kbShiftF6,cmLinksSel,hcNoContext,
      NewItem('~4~  ()','Shift-F7',kbShiftF7,cmProjectSel,hcNoContext,
      NewLine(
      NewItem('~5~ ','Shift-F4',kbShiftF4,cmSortSel, hcNoContext,
      NewItem('~6~   ()','Shift-F1',kbShiftF1,cmPrintSel,hcNoContext,
      NewItem('~7~  ','Shift-F2',kbShiftF2,cmCountSumm,hcNoContext,
      nil))))))))
     ),
    NewSubMenu('~4~ ',hcNoContext,NewMenu(
      NewItem('~1~  ',
       '',kbNoKey,cmAbout,hcNoContext,
      nil)),
    nil)))))
  ));
 end;

procedure TSRDBApp.InitStatusLine;
 var R: TRect;
 function New_Esc(P:PStatusItem): PStatusItem;
  begin New_Esc:=NewStatusKey('~Esc~ ', kbEsc, cmClose,P) end;
 function New_Can(P:PStatusItem): PStatusItem;
  begin New_Can:=NewStatusKey('~Esc~ ', kbEsc, cmCancel,P) end;
 function New_Sel(P:PStatusItem): PStatusItem;
  begin New_Sel:=New_Can(NewStatusKey('~Enter~ ',kbEnter,cmClose,P)) end;
 function New_ER(P:PStatusItem): PStatusItem;
  begin New_ER:=New_Can(NewStatusKey('~F1~ ',kbF1,cmOK,P)) end;
 function New_CanClose(P:PStatusItem): PStatusItem;
  begin New_CanClose:=New_Can(NewStatusKey('~F1~ ',kbF1,cmClose,P)) end;
 function QuerySortList(P:PStatusItem): PStatusItem;
  begin QuerySortList:=New_CanClose(
   NewStatusKey('~F2~ ',kbF2,cmAddSortEl,
   NewStatusKey('~F3~ ',kbF3,cmDelSortEl,
   P)))
  end;
 function NextPrevWinKeys: PStatusItem;
  begin NextPrevWinKeys:=
   NewStatusKey('', kbTab,      cmNext,
   NewStatusKey('', kbShiftTab, cmPrev, nil))
  end;
 const
  uskBrouse = 0;
  uskSelect = 1;
  uskInclud = 2;
  uskSetBrs = 3;
 function UseStatusKeys(usk:byte):PStatusItem;
  function Tail_0:PStatusItem;
   begin Tail_0:=
    NewStatusKey('~F7~ ',    kbF7,cmMixRec,
    NewStatusKey('~F8~ ',kbF8,cmDupRec,
    NextPrevWinKeys))
   end;
  function Tail_1:PStatusItem;
   var Tail:PStatusItem;
   begin
    case usk of
     uskBrouse,uskInclud,uskSetBrs:Tail:=
     NewStatusKey('~F6~ ',kbF6,cmRecLinks,Tail_0);
     uskSelect:Tail:=Tail_0;
    end;
    case usk of
     uskBrouse,uskSelect:Tail_1:=
     NewStatusKey('~F4~ ', kbF4, cmOrder,
     NewStatusKey('~F5~ ',  kbF5, cmPart,
     Tail));
     uskInclud,uskSetBrs:Tail_1:=Tail;
    end;
   end;
  begin
   UseStatusKeys:=
    NewStatusKey('~F1~ ',   kbF1, cmNewRec,
    NewStatusKey('~F2~ ',  kbF2, cmEditRec,
    NewStatusKey('~F3~ ',   kbF3, cmDelRec,
    Tail_1)))
  end;
 begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
   NewStatusDef(1800, 1899, { Colapse File List }
    New_CanClose(
     NewStatusKey('~F2~   ',kbF2,cmSetSorsFld,
     NewStatusKey('~F3~  ', kbF3,cmSetFldValue,nil))),
   NewStatusDef(1700, 1799, { Edit Query List }
    QuerySortList(
     NewStatusKey('~F4~ ',kbF4,cmToggle,
     NewStatusKey('~F5~ ', kbF5,cmChFldVal,Nil))),
   NewStatusDef(1600, 1699, { Edit Sort List }
    QuerySortList(NewStatusKey('~F4~  ',kbF4,cmToggle,Nil)),
   NewStatusDef(1500, 1599, { Field select }
    New_Sel(NewStatusKey('~F2~ /',kbF2,cmExpColaps,Nil)),
   NewStatusDef(1450, 1499, { Included Brouser }
    New_Esc(UseStatusKeys(uskInclud)),
   NewStatusDef(1400, 1449, { Selection brouser }
    New_Esc(UseStatusKeys(uskSetBrs)),
   NewStatusDef(1350, 1399, { Record selector }
    New_Sel(UseStatusKeys(uskSelect)),
   NewStatusDef(1300, 1349, { Record brouser }
    New_Esc(UseStatusKeys(uskBrouse)),
   NewStatusDef(1200, 1299, { Field brouser }
    New_Esc(
     NewStatusKey('~F1~ ',  kbF1, cmNewFld,
     NewStatusKey('~F2~ ', kbF2, cmEditFld,
     NewStatusKey('~F3~ ', kbF3, cmDelFld,
     NextPrevWinKeys)))),
   NewStatusDef(1000, 1009, { Edit record part of record }
    New_ER(nil),
   NewStatusDef(1010, 1019, { Edit pointer part of record }
    New_ER(NewStatusKey('~F2~ ', kbF2, cmEditPtr,Nil)),
   NewStatusDef(1020, 1029, { File brouser }
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,
    NewStatusKey('~Enter~ ',kbEnter,cmUse,
    NextPrevWinKeys)),
   NewStatusDef(1100, 1110, { Simple chois }
    New_Sel(Nil),
   NewStatusDef($0000, $FFFF,
    NewStatusKey('~Alt-X~ ', kbAltX, cmQuit,Nil),
   nil))))))))))))))));
 end;

procedure TSRDBApp.DoAboutBox;
begin MessageBox(
  #3+'  SRDB,         1.0'+#13+
  #3+'(c)   (. )  1997'+#13+
  #3+' ,  .(042) 86-91-06'+#13+
  #3+'      ',
  nil, mfInformation or mfOKButton);
end;
