unit cli_brs0;
interface

{$I options.pp}

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 win_def, common,
 cli_data, cli_proc,
 Views, Drivers;

type
 PBrsProcess  = ^TBrsProcess;
 TBrsProcess  = object (TLocalProcess)
  procedure Answer(cmd:byte; var Data); virtual;
 end;
 PDLineHead = ^TDLineHead;
 TDLineHead = record
  Ready:boolean;
  RecInd:longint;
 end;
 PDataWin = ^TDataWin;
 TDataWin = object
  YSize,RSize:byte; PDW:PBlock; SesId:word;
  constructor Init(aX,aY:byte);
  procedure Clear;
  procedure SetLine(dy:byte; aRecInd:longint; s:TStr80);
  function Line(dy:byte):TStr80;
  function RecNo(dy:byte):longint;
  function LineReady(dy:byte):boolean;
  destructor Done;
 end;
 PFileBrouser = ^TFileBrouser;
 TFileBrouser = object (TBrouseWindow)
  { -------- Common vars --------- }
  MyId:byte; PDF:PDataFile;
  AfterY:byte; SummCounted:boolean;
  ExFld:byte;
  PLP:PBrsProcess;
  Limits:TlpLimits; LimitsReady:boolean;
  PPatWin:PDataWin; PatInd:longint; PatFile:byte;
  PRecWin:PDataWin;
  PDW:PDataWin; DataWinReady:boolean;
  {--------- Eval vars: -----------}
  LastInd:longint; LastIndReady:boolean;
  { ------------------------------ }
  constructor Init(aMyId,aExFld,aBrType,aVstart,aVafter:byte);
  destructor Done; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  function LastLine:longint; virtual;
  procedure ShowWCursor; virtual;
  procedure NewDataWin; virtual;
  procedure SetICursor; virtual;
  procedure SetIndCursor; virtual;
  procedure ShowCnt; virtual;
  procedure ShowCnt_1; virtual;
  procedure ShowCnt_2; virtual;
  procedure ShowSumm(Eval:boolean);
  function Line(l:longint):string; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure CorrectEnable; virtual;
  function  RecOK:boolean; virtual;
{
  procedure EraseSel;
}
 private
  procedure ShowModifiedRec(aPtr:pointer); virtual;
  procedure ClearLimits;
  procedure WriteSummLine(s:string);
  procedure SetOrder;
  procedure SetPart;
  procedure RecLinks;
  procedure ModifyRec(old,dup:boolean);
  function  NextInd:longint; virtual;
  procedure EraseOrMix(OldInd,NewInd,ShowInd:longint);
  procedure EraseRec;
  procedure MixRec;
{  
  procedure FullSel;
  procedure QuerySel;
  procedure LinksSel;
  procedure ProjectSel;
  procedure WriteSummLine(s:string);
  function  EvalSummLine:string;
  procedure ShowSumm(Eval:boolean);
  procedure SortSel;
  procedure PrintSel;
}
  procedure ShowULine(LnId,FldId:byte); virtual;
  function  ULinOK(FldId:byte; var LnId:byte):boolean;
 end;
 PStdBrouse = ^TStdBrouse;
 TStdBrouse = object (TFileBrouser)
  constructor Init(aFId:byte);
 end;
 PStdSelectOne = ^TStdSelectOne;
 TStdSelectOne = object (TFileBrouser)
  PPtr:^longint;
  constructor Init(aFId:byte; var Ind:longint);
  procedure HandleEvent(var Event:TEvent); virtual;
 end;
 PStdIncluded = ^TStdIncluded;
 TStdIncluded = object (TFileBrouser)
  constructor Init(aFId:byte; aInd:longint; aExFld:byte);
  destructor Done; virtual;
  function GetTitle(MaxSize: Integer): TTitleStr; virtual;
  procedure ShowCnt_1; virtual;
 private
  procedure DrawHdLine(i:byte);
  procedure ShowModifiedRec(aPtr:pointer); virtual;
  procedure GetHeader;
 end;

implementation

uses
 Cli_Recs, Cli_Tran,
 Menu_cmd, TV_box, Str_Def, { SPX_Def,}
 App, Objects;

{---------------------------------------------------}

function FileBrStr(FileId:byte; aRL:TlpRecLineA):TStr80;
 var Fld:TFldRec; 
 begin with aRL do begin
  FileBrStr:=BrStr;
  DFArr[FileId]^.Fields^.GetRec(FldId,Fld);
  if Fld.FType<>cfPntr then
    FileBrStr:=copy(FldStdString(Fld,Value),1,80);
 end end;

{---------------------------------------------------}

const
 spUnderLWin = 0;
 spHeaderWin = 1;

procedure TBrsProcess.Answer(cmd:byte; var Data);
 var
  LnId:byte;
  PFB : PFileBrouser absolute MyWin;
  PSI : PStdIncluded absolute MyWin;
  aLimits:TlpLimits    absolute Data;
  aLine  :TlpDataLineA absolute Data;
  aRLine :TlpRecLineA  absolute Data;
 begin case cmd of
  lpLimits:begin
    with PFB^ do begin
     Limits:=aLimits;
     LimitsReady:=True;
     DataWinReady:=False;
     SetICursor;
     DataWinReady:=True;
     NewDataWin;
    end;
   end;
  lpDataLineA:
   with PFB^ do if aLine.SesId=PDW^.SesId then with aLine do begin
    PDW^.SetLine(WinDY,RecInd,BrStr);
    DrawLine(WinDY);
   end;
  lpRecLineA:case aRLine.SubProcess of
   spUnderLWin:with PFB^ do if aRLine.SesId=PRecWin^.SesId
    then with aRLine do if ULinOK(FldId,LnId) then begin
     PRecWin^.SetLine(LnId,0,FileBrStr(MyId,aRLine));
     ShowULine(LnId,FldId);
    end;
   spHeaderWin:with PSI^ do if aRLine.SesId=PPatWin^.SesId
    then with aRLine do begin
     PPatWin^.SetLine(FldId,0,FileBrStr(PatFile,aRLine));
     DrawHdLine(FldId);
    end;
  end;
 end end;

constructor TDataWin.Init(aX,aY:byte);
 var Size:word;
 begin
  YSize:=aY; RSize:=SizeOf(TDLineHead)+1+aX; SesId:=0;
  Size:=YSize; GetMem(PDW,Size*RSize);
 end;
destructor TDataWin.Done;
 var Size:word;
 begin Size:=YSize; FreeMem(PDW,Size*RSize) end;
procedure TDataWin.Clear;
 var p:PDLineHead; i:word;
 begin
  for i:=0 to YSize-1 do begin
   p:=addr(PDW^[i*RSize]);
   p^.Ready:=False;
  end;
  inc(SesId);
 end;
procedure TDataWin.SetLine(dy:byte; aRecInd:longint; s:TStr80);
 var p:PDLineHead; aSize:word; aSLen:byte; ps:^TStr80;
 begin
  aSize:=RSize; aSLen:=aSize-SizeOf(TDLineHead)-1;
  aSize:=aSize*DY; p:=addr(PDW^[aSize]);
  p^.Ready:=True; p^.RecInd:=aRecInd;
  ps:=addr(PDW^[aSize+SizeOf(TDLineHead)]);
  ps^:=copy(s,1,aSLen);
 end;
function TDataWin.Line(dy:byte):TStr80;
 var aSize:word; ps:^TStr80;
 begin
  aSize:=RSize; ps:=addr(PDW^[aSize*dy+SizeOf(TDLineHead)]);
  Line:=ps^;
 end;
function TDataWin.RecNo(dy:byte):longint;
 var aSize:word; p:PDLineHead;
 begin
  aSize:=RSize; p:=addr(PDW^[aSize*dy]);
  RecNo:=p^.RecInd;
 end;
function TDataWin.LineReady(dy:byte):boolean;
 var p:PDLineHead; aSize:word;
 begin
  aSize:=RSize; p:=addr(PDW^[aSize*dy]);
  LineReady:=p^.Ready;
 end;

{---------------------------------------------------}

constructor TFileBrouser.Init(
 aMyId,aExFld,aBrType,aVstart,aVafter:byte);
 var
  s:string; R:TRect; aDX,aAY,aVS:byte; aSLE,Sucess:boolean;
 begin
  aAY:=aVafter; if aAY>0 then inc(aAY);
  s:=DFArr[aMyId]^.StdHeaderLine(aExFld,aSLE);
  aDX:=min(79,Length(s)); aDX:=max(20,aDX);
  if (aVafter>0) or (aExFld<>$FF) then aDX:=max(50,aDX);
  aVS:=max(4+(ord(aSLE) shl 1),
        min(DFArr[aMyId]^.FilSize+2+(ord(aSLE) shl 1),
        Desktop^.Size.Y-1-aVStart-aAY));
  R.Assign(0,0,aDX+1,aVS+aVStart+aAY+1);
  case aBrType of
   bwUChois:R.Move(79-aDX,0);
   bwUIncl,bwUSet:R.Move((80-aDX) div 2,0);
  end;
  inherited Init(aBrType,Nil,R,aVStart,aVS,copy(s,1,aDX-1),aSLE);
  ExFld:=aExFld; AfterY:=aAY; MyId:=aMyId; PDF:=DFArr[MyId];
  MyCmdSet:=
   TCommandSet(UseCmdSet)+
   TCommandSet([cmClose,cmCancel,cmPrev,cmNext]);
  ClearLimits;
  New(PLP,Init(@Self,Sucess));
  New(PDW,Init(DrawSize.X,DrawSize.Y));
  if AfterY>0 then New(PRecWin,Init(DrawSize.X,AfterY));
 end;
destructor TFileBrouser.Done;
 begin
  if AfterY>0 then Dispose(PRecWin,Done);
  Dispose(PDW,Done);
  Dispose(PLP,Done);
  inherited Done;
 end;
procedure TFileBrouser.ClearLimits;
 begin
  LimitsReady:=False;
  With Limits do begin
   FileId:=MyId;
   LimitStr:='request to server ...';
  end;
  WinCursor:=0; Frame^.Draw; DrawView;
 end;
procedure TFileBrouser.NewDataWin;
 var LinQuest:TlpDataLines;
 begin if LimitsReady and DataWinReady then begin
  PDW^.Clear;
  with LinQuest do begin
   FileId:=MyId;
   IndexId:=Limits.IndexId;
   CurStart:=Limits.CurStart;
   CurEnd:=Limits.CurEnd;
   WinStart:=DeltaV;
   WinMax:=PDW^.YSize;
   aExFld:=ExFld;
   SesId:=PDW^.SesId;
  end;
  PLP^.Question(lpDataLines,LinQuest,SizeOf(LinQuest));
 end end;
function TFileBrouser.GetTitle(MaxSize: Integer): TTitleStr;
 var sd:string[80]; L:longint; s:string;
 begin
  L:=PDF^.FilSize; Str(L,sd);
{$IFDEF Cir}
  sd:=sd+' '; if L<>1 then sd:=sd+'';
  s:=PDF^.LName+': '+sd; Str(PDF^.RecSize,sd);
  sd:=sd+' '; if PDF^.RecSize<>1 then sd:=sd+'';
  if L<>1 then sd:='  '+sd else sd:='  '+sd;
{$ENDIF}{$IFDEF Lat}
  sd:=sd+' record'; if L<>1 then sd:=sd+'s';
  s:=PDF^.LName+': '+sd; Str(PDF^.RecSize,sd);
  sd:=sd+' byte'; if PDF^.RecSize<>1 then sd:=sd+'s';
  sd:=', each is '+sd+' long';
{$ENDIF}
  GetTitle:=copy(s+sd,1,MaxSize);
 end;
function TFileBrouser.LastLine:longint;
{ var Sel:PFileVirtSel absolute PData; }
 begin
  if LimitsReady
   then with Limits do LastLine:=CurEnd-CurStart
   else LastLine:=0;
 end;
procedure TFileBrouser.ShowCnt_1;
 begin
  WriteStr(DrawPos.x,1,JustStr(Limits.LimitStr,Size.X-2),1);
 end;
procedure TFileBrouser.WriteSummLine(s:string);
 begin WriteStr(DrawPos.x,DrawPos.y+DrawSize.Y+1,JustStr(s,Size.X-2),1) end;
(*
function TFileBrouser.EvalSummLine:string;
 var
  Sel:PFileVirtSel absolute PData;
  PB:PBlock; i,Ind:longint; MaxFld,j:byte;
  FPos:array[0..FldMaxCnt] of word;
  FTyp:array[0..FldMaxCnt] of byte;
  FFlg:array[0..FldMaxCnt] of boolean;
 procedure Prepare;
  var c:word; j:byte; Fld:TFldRec;
  begin with PDF^ do begin
   MaxFld:=Fields^.Length-1; c:=1;
   for j:=0 to MaxFld do begin
    Fields^.GetRec(j,Fld);
    FPos[j]:=c; FTyp[j]:=Fld.FType;
    FFlg[j]:=Fld.GetFlags(ffCntSumm);
    inc(c,Fld.Size);
   end;
  end end;
 procedure AddNum(t:byte; var s,d);
  var rs:real absolute s; rd:real absolute d;
      ls:longint absolute s; ld:longint absolute d;
  begin case t of CFReal:rd:=rd+rs; CFLong:ld:=ld+ls; end end;
 begin
  GetMem(PB,PDF^.RecSize); PDF^.RecClear(PB^); Prepare;
  if LastLine>0 then for i:=0 to LastLine-1 do begin
   if RecOK(i) then
    for j:=0 to MaxFld do if (j<>ExFld) and FFlg[j]
     then AddNum(FTyp[j],Sel^.PR^[FPos[j]],PB^[FPos[j]]);
   if (i and $1F)=0
    then WriteSummLine(PDF^.StdBrouseLine(-1,i,PB^,ExFld,True));
  end;
  EvalSummLine:=PDF^.StdBrouseLine(-1,-1,PB^,ExFld,True);
  FreeMem(PB,PDF^.RecSize);
 end;
*)
procedure TFileBrouser.ShowSumm(Eval:boolean);
 begin
  { if Eval
   then WriteSummLine(EvalSummLine)
   else } WriteSummLine(PDF^.StdSummLine(ExFld));
  SummCounted:=Eval;
 end;
procedure TFileBrouser.ShowCnt_2;
 var s:string; c,i:byte;
 begin
  if GetState(sfDragging) then c:=3
   else if GetState(sfActive) then c:=2 else c:=1;
  if LimitsReady
   then Str(LastLine,s)
   else s:='???';
{$IFDEF Cir}
  s:=Copy(' '+s+'  ',1,Size.X-3);
{$ENDIF}{$IFDEF Lat}
  s:=Copy(' '+s+' selected ',1,Size.X-3);
{$ENDIF}
  for i:=length(s)+1 to Size.X-3 do
   if (HeadLine[i+1]=VLChar) and (AfterY=0) then s:=s+'' else s:=s+'';
  WriteStr(2,Size.Y-1,s,c);
 end;
procedure TFileBrouser.ShowCnt;
 begin
  ShowCnt_1; ShowCnt_2;
  if SummLineExist then ShowSumm(LastLine<50);
 end;
procedure TFileBrouser.ShowULine(LnId,FldId:byte);
 var Fld:TFldRec; v0:byte; s:string;
 begin with PDF^ do begin
  v0:=DrawPos.y+DrawSize.Y+1; if SummLineExist then Inc(v0,2);
  if PRecWin^.LineReady(LnId)
   then s:=PRecWin^.Line(LnId) else s:='$'+HexLong(LastInd);
  WriteStr(DrawPos.x,v0+LnId,JustStr(FldName(FldId)+': '+s,Size.X-2),1);
 end end;
function TFileBrouser.ULinOK(FldId:byte; var LnId:byte):boolean;
 var i:byte;
 begin with PDF^ do begin
  LnId:=0; i:=0;
  while i<FldId do begin
   if FldULin(i) and (i<>ExFld) then inc(LnId); inc(i); end;
  ULinOK:=FldULin(i) and (i<>ExFld)
 end end;
procedure TFileBrouser.ShowWCursor;
 var i,j,v0:byte; TRL:TlpRecLines; LIR:boolean; LI:longint;
 procedure ClUlines;
  var i:byte;
  begin
   PRecWin^.Clear;
   for i:=1 to AfterY-1 do WriteStr(DrawPos.x,v0+i,Blank(Size.X-2),1)
  end;
 begin if GetState(sfVisible) then begin
  LIR:=LastIndReady; LI:=LastInd;
  inherited ShowWCursor;
  LastIndReady:=false;
  if LimitsReady
   then if DataWinReady and PDW^.LineReady(WinCursor-DeltaV) then begin
    LastIndReady:=True;
    LastInd:=PDW^.RecNo(WinCursor-DeltaV);
   end;
  v0:=DrawPos.y+DrawSize.Y;
  if SummLineExist then Inc(v0,2);
  if AfterY>0 then
   if LastIndReady and (LastInd<>-1) then with PDF^ do begin
    if (LIR<>LastIndReady) or (LI<>LastInd) then begin
     PRecWin^.Clear;
     with TRL do begin
      SesId:=PRecWin^.SesId; SubProcess:=spUnderLWin;
      FileId:=MyId; RecId:=LastInd;
     end;
     PLP^.Question(lpRecLines,TRL,SizeOf(TRL));
    end;
    i:=0;
    for j:=0 to Fields^.Length-1 do
     if FldULin(j) and (j<>ExFld) then begin ShowULine(i,j); inc(i) end;
   end else ClULines;
 end end;
function TFileBrouser.Line(l:longint):string;
 var s:string;
 begin
  if LimitsReady
   then if l>LastLine
    then Line:=BlankLine
    else if DataWinReady and PDW^.LineReady(l-DeltaV)
     then Line:=PDW^.Line(l-DeltaV)
     else begin
      s:=BlankLine;
      ReplStr(s,'L:$'+HexLong(l),2);
      Line:=s
     end
   else Line:=BlankLine;
 end;
procedure TFileBrouser.SetICursor;
 begin
  if LimitsReady
   then WinCursor:=Limits.WinInd
   else WinCursor:=LastLine;
  SetWCursor(WinCursor);
 end;
procedure TFileBrouser.CorrectEnable;
 begin
  if not RecOK then DisableCommands(TCommandSet(UseCmdSet1));
  case bwCase of
   bwUIncl,bwUSet:DisableCommands(TCommandSet([cmOrder,cmPart]));
  end;
  case bwCase of
   bwURoot,bwUChois,bwUIncl:DisableCommands(TCommandSet([cmSortSel]));
  end;
  case bwCase of
   bwUChois:DisableCommands(TCommandSet(UseCmdSet2));
  end;
  if PDF^.FLCnt=0 then DisableCommands(TCommandSet([cmRecLinks,cmLinksSel]));
  if SummCounted or (not SummLineExist) 
   then DisableCommands(TCommandSet([cmCountSumm]));
 end;
procedure TFileBrouser.HandleEvent(var Event: TEvent);
 var PFB:PFileBrouser;
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evBroadcast:case Event.Command of
    cmSetCursor:begin ShowModifiedRec(Event.InfoPtr); Exit end;
    else Exit;
   end;
   evCommand:case Event.Command of
    cmOrder:SetOrder;
    cmPart:SetPart;
    cmRecLinks:RecLinks;
    cmEditRec,cmBrouseDouble:if RecOK then ModifyRec(true,false);
    cmNewRec:ModifyRec(false,false);
    cmDupRec:ModifyRec(false,true);
    cmDelRec:EraseRec;
    cmMixRec:MixRec;
{
    cmFullSel:FullSel;
    cmLinksSel:LinksSel;
    cmProjectSel:ProjectSel;
    cmQuerySel:QuerySel;
    cmSortSel:SortSel;
    cmPrintSel:PrintSel;
    cmCountSumm:ShowSumm(True);
    cmEraseSel:EraseSel;
}
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

{------------------------------------------------------}

function TFileBrouser.RecOK:boolean;
 begin
  RecOK:=False;
  if LimitsReady
   then if DataWinReady and PDW^.LineReady(WinCursor-DeltaV)
    then RecOK:=PDW^.RecNo(WinCursor-DeltaV)<>-1;
 end;
function TFileBrouser.NextInd:longint;
 var DY:byte;
 begin
  NextInd:=-1;
  { only interval windows: }
  DY:=WinCursor+1-DeltaV;
  with PDW^ do if DY<YSize then if LineReady(DY) then NextInd:=RecNo(DY);
 end;

procedure TFileBrouser.SetIndCursor;
 begin
  With Limits do begin
   if LastIndReady then RecInd:=LastInd else RecInd:=-1;
   EvalWinInd:=true;
  end;
  ClearLimits;
  PLP^.Question(lpLimits,Limits,SizeOf(Limits));
 end;

procedure TFileBrouser.ShowModifiedRec(aPtr:pointer);
 var PMR:PModifyRecord absolute aPtr;
 begin
  SetIndCursor;
 end;

procedure TFileBrouser.EraseOrMix(OldInd,NewInd,ShowInd:longint);
 begin case ErasRec(MyId,OldInd,NewInd) of
  ErasSucess:LastInd:=ShowInd;
  EProtected:ErrNum(esRecIsNowUsd);
  EErased:LifeError('Rec was erased');
  LnkInUse:ErrNum(esLnkRecInUse);
 end end;
procedure TFileBrouser.EraseRec;
 begin if YN_Num2(esEraseRecMsg,esAreYouShure)
  then EraseOrMix(LastInd,-1,NextInd) end;
procedure TFileBrouser.MixRec;
 var Sors,Dest:longint;
 begin
  Sors:=LastInd; Dest:=-1;
  LepkaNumEdit(MyId,Sors,Dest);
  if (Sors>=0) and (Dest>=0) and (Sors <> Dest)
   then EraseOrMix(Sors,Dest,Dest);
 end;

procedure TFileBrouser.ModifyRec(old,dup:boolean);
 var
  PB,PBO:PBlock; Ind:longint;
  Cont0,EditOK:boolean; s:string[12];
 begin
  GetMem(PB,PDF^.RecSize); GetMem(PBO,PDF^.RecSize); Ind:=LastInd;
  if old or dup
   then case LoadRec(MyId,Ind,PB^,old) of { Load rec; lock if old }
    LoadSucess:Cont0:=True;
    Protected:begin Cont0:=False; ErrNum(esProtRecordE) end;
    Erased:begin Cont0:=False; LifeError('Rec was erased') end;
   end
   else begin
    PDF^.RecClear(PB^);
    if ExFld<>$FF then Move(PatInd,PB^[PDF^.FldPos(ExFld)],4);
    Cont0:=True;
   end;
  if Cont0 then begin { Rec was loaded, edit folows ... }
   if old then Move(PB^,PBO^,PDF^.RecSize);
   EditOK:=InputLayout(PB^,MyId,Ind,bwCase,ExFld);
   if EditOK and old then EditOK:=not equ(PB^,PBO^,PDF^.RecSize);
{
   if EditOK and old then LifeError('Edit is OK');
}
   if old or EditOK then begin
    case SaveRec(MyId,Ind,PB^,old,EditOK) of
     SaveSucess:LastInd:=Ind;
     UniqueErr:begin
       Str(Ind,s); LifeError(ErrStr(esBadDupAttmp)+PDF^.LName+'['+s+']');
       LastInd:=Ind; SetIndCursor;
      end;
     else LifeError('undefined SaveRec value'); 
    end;
   end;
  end;
  FreeMem(PBO,PDF^.RecSize); FreeMem(PB,PDF^.RecSize);
 end;

procedure TFileBrouser.SetOrder;
 var i:byte;
 begin
  i:=Limits.IndexId; PDF^.SelectIndex(i);
  With Limits do begin IndexId:=i; Ltd:=False end;
  SetIndCursor;
 end;

procedure TFileBrouser.SetPart;
 var Fld:TFldRec;
 begin if Limits.IndexId<>$FF then begin
  With Limits do begin
   PDF^.Fields^.GetRec(IndexId,Fld);
   FldChangeLimits(Fld,Limits,Ltd);
  end;
  SetIndCursor;
 end end;

procedure TFileBrouser.RecLinks;
 var i:byte;
 begin
  i:=PDF^.LinkChois;
  if i<PDF^.FLCnt then begin
   PDF^.LastFileLink:=i;
   if LastIndReady
    then with PDF^.FLArr[i] do if DFArr[FileId]^.Fields^.Length>1
     then Application^.InsertWindow(
      New(PStdIncluded,Init(FileId,LastInd,FldId)))
     else LifeError('No extra data fields')
    else LifeError('Record was modified by server');
  end;
 end;

{------------------------------------------------------}

constructor TStdBrouse.Init(aFId:byte);
 Const Y0 = 5;
 begin
  inherited Init(aFId,$FF,bwURoot,Y0,DFArr[aFId]^.FullShowCount);
  HelpCtx:=hcUseFile;
  With Limits do begin
   IndexId:=PDF^.SelectFIndex; Ltd:=False;
   RecInd:=-1; EvalWinInd:=true;
  end;
  PLP^.Question(lpLimits,Limits,SizeOf(Limits));
 end;

{------------------------------------------------------------}

constructor TStdIncluded.Init(aFId:byte; aInd:longint; aExFld:byte);
 var Fld:TFldRec; y0,aYH:byte;
 begin
  DFArr[aFId]^.Fields^.GetRec(aExFld,Fld);
  if FldGetFlags(Fld,ffFulShow) then y0:=1 else y0:=0;
  aYH:=4+DFArr[Fld.FPtr]^.Fields^.Length;
  inherited Init(aFId,aExFld,bwUIncl,aYH,DFArr[aFId]^.FullShowCount-y0);
  HelpCtx:=hcIncluded; PatInd:=aInd; PatFile:=Fld.FPtr;
  { --------------------- }
  New(PPatWin,Init(DrawSize.X,aYH-4));
  GetHeader;
  { --------------------- }
  With Limits do begin
   IndexId:=aExFld; Ltd:=True;
   Move(PatInd,Limits,SizeOf(PatInd));
   RecInd:=-1; EvalWinInd:=true;
  end;
  PLP^.Question(lpLimits,Limits,SizeOf(Limits));
 end;
procedure TStdIncluded.GetHeader;
 var TRL:TlpRecLines;
 begin
  PPatWin^.Clear;
  with TRL do begin
   SesId:=PPatWin^.SesId; SubProcess:=spHeaderWin;
   FileId:=PatFile; RecId:=PatInd;
  end;
  PLP^.Question(lpRecLines,TRL,SizeOf(TRL));
 end;
destructor TStdIncluded.Done;
 begin
  Dispose(PPatWin,Done);
  inherited Done;
 end;
function TStdIncluded.GetTitle(MaxSize: Integer): TTitleStr;
 begin
{$IFDEF Cir}
  GetTitle:=copy(PDF^.LName+';  '+PDF^.FldName(ExFld)+'   ',1,MaxSize);
{$ENDIF}{$IFDEF Lat}
  GetTitle:=copy(PDF^.LName+'; field '+PDF^.FldName(ExFld)+' is fixed ',1,MaxSize);
{$ENDIF}
 end;
procedure TStdIncluded.DrawHdLine(i:byte);
 var s1:string[FldMaxLen+2]; s2:TStr80;
 begin
  s1:=' '+PDF^.FldName(ExFld)+'.';
  if { PB^[0]=$FF } PatInd=-1
{$IFDEF Cir}
   then WriteStr(DrawPos.x,1+i,'    ',2)
{$ENDIF}{$IFDEF Lat}
   then WriteStr(DrawPos.x,1+i,' Erased or dummy record ',2)
{$ENDIF}
   else begin
    if i>0 then s1:=Blank(length(s1));
    if PPatWin^.LineReady(i)
     then s2:=PPatWin^.Line(i)
     else if i=0 then s2:='PatRec: $'+HexLong(PatInd) else s2:='';
    WriteStr(DrawPos.x,1+i,
     JustStr(s1+DFArr[PatFile]^.FldName(i)+': '+s2,Size.X-2),2);
   end;
 end;
procedure TStdIncluded.ShowCnt_1;
 var i:byte;
 begin if LimitsReady then
  for i:=0 to DFArr[PatFile]^.Fields^.Length-1 do DrawHdLine(i)
 end;
procedure TStdIncluded.ShowModifiedRec(aPtr:pointer);
 var PMR:PModifyRecord absolute aPtr;
 begin
  if (PatFile=PMR^.FileId) and (PatInd=PMR^.RecId) then GetHeader;
  inherited ShowModifiedRec(aPtr);
 end;

{------------------------------------------------------}

constructor TStdSelectOne.Init(aFId:byte; var Ind:longint);
 Const Y0 = 5;
 begin
  inherited Init(aFId,$FF,bwUChois,Y0,DFArr[aFId]^.FullShowCount);
  HelpCtx:=hcSelOne; PPtr:=addr(Ind); LastInd:=PPtr^;
  With Limits do begin
   IndexId:=PDF^.SelectFIndex; Ltd:=False;
   RecInd:=LastInd; EvalWinInd:=true;
  end;
  PLP^.Question(lpLimits,Limits,SizeOf(Limits));
 end;

procedure TStdSelectOne.HandleEvent(var Event:TEvent);
 var Handled:boolean;
 procedure CloseSelf(Command:word);
  begin
   EndModal(Command); Handled:=true;
   if Command=cmClose then if RecOk
    then PPtr^:=LastInd
    else PPtr^:=-1;
  end;
 begin
  Handled:=false;
  case Event.What of
   evCommand:case Event.Command of
    cmCancel, cmClose: CloseSelf(Event.Command)
   end;
  end;
  if Handled then ClearEvent(Event) else inherited HandleEvent(Event);
 end;

{------------------------------------------------------------}

end.
