unit cli_data;
interface

{$I options.pp}

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 Common, Cli_Recs, Views;

const
 FileLinkMax = 20;

type
 TFieldId = record FileId, FldId:byte end;
 PFieldArray = ^TFieldArray;
 TFieldArray = object
  constructor Init;
  function Length:byte;
  procedure GetRec(i:byte; var Fld:TFldRec);
  procedure Append(Fld:TFldRec);
 private
  Cnt:byte;
  A:array[0..FldMaxCnt] of TFldRec;
 end;

 PDataFile = ^TDataFile;
 TDataFile = object 
  FName:SmallFName;
  LName:LongFName;
  SName:ShortFName;
  Status:byte;
  CntSize:byte;
  FLCnt:byte;
  FLArr:array[0..FileLinkMax] of TFieldId;
  LastFileLink, LastUsedIndex:byte;
  RecSize:word;
  FilSize:longint; {  }
  Fields:PFieldArray;
  constructor Open(FS:TFileStructure);
  destructor Done;
  function FldName(FldId:byte):string;
  function FldType(FldId:byte):byte;
  function FldPos(FldId:byte):word;
  function FldULin(FldId:byte):boolean;
  function FldNameLnks(FldId:byte):string;
  function LinkChois:byte;
  function StdHeaderLine(ExFld:byte; var SummLineExist:boolean):string;
  function StdSummLine(ExFld:byte):string;
  function FullShowCount:byte;
  function SelectFIndex:byte;
  procedure SelectIndex(var IndexId:byte);
  procedure RecClear(var Rec);
 end;

var
 DFArr:array[0..254] of PDataFile;

procedure SetUserMode;

implementation

uses
 TV_box, Win_Def, Str_Def, TCP_Clnt,
 App, Drivers, Objects;

{------------------------------------------------------}

constructor TFieldArray.Init; begin Cnt:=0 end;
function TFieldArray.Length:byte; begin Length:=Cnt end;
procedure TFieldArray.GetRec(i:byte; var Fld:TFldRec); begin Fld:=A[i] end;
procedure TFieldArray.Append(Fld:TFldRec); begin A[Cnt]:=Fld; inc(Cnt) end;

{------------------------------------------------------}

constructor TDataFile.Open(FS:TFileStructure);
 var i:byte; Buf:TNetBuf; Fld:TFldRec absolute Buf;
 begin
  with FS do begin
   FName:=DFN.FName;
   LName:=DFN.LName;
   SName:=DFN.SName;
   Status:=DFN.Status;
   CntSize:=DFN.CntSize;
  end;
  FilSize:=FS.FilSize;
  New(Fields,Init); RecSize:=1;
  with Fields^ do if FS.FldCnt>0 then for i:=0 to FS.FldCnt-1 do
   if Server^.Used then begin
    WaitFromServer(ncFieldStructur,Buf);
    inc(RecSize,Fld.Size); Append(Fld);
   end;
 end;
destructor TDataFile.Done;
 begin Dispose(Fields) end;
function TDataFile.FldName(FldId:byte):string;
 var Fld:TFldRec;
 begin
  Fields^.GetRec(FldId,Fld);
  FldName:=ClearSp(RecStr(Fld.Name,FldMaxLen));
 end;
function TDataFile.FldType(FldId:byte):byte;
 var Fld:TFldRec;
 begin
  Fields^.GetRec(FldId,Fld);
  FldType:=Fld.FType;
 end;
function TDataFile.FldPos(FldId:byte):word;
 var i,c:word; Fld:TFldRec;
 begin
  i:=0; c:=1;
  while i<FldId do begin Fields^.GetRec(i,Fld); inc(c,Fld.Size); inc(i) end;
  FldPos:=c;
 end;
function TDataFile.FullShowCount:byte;
 var i,c:byte; Fld:TFldRec;
 begin
  c:=0;
  if Fields^.Length>0 then for i:=0 to Fields^.Length-1 do
   begin Fields^.GetRec(i,Fld); if FldGetFlags(Fld,ffFulShow) then inc(c) end;
  FullShowCount:=c;
 end;
function TDataFile.FldULin(FldId:byte):boolean;
 var Fld:TFldRec;
 begin
  Fields^.GetRec(FldId,Fld);
  FldULin:=FldGetFlags(Fld,ffFulShow);
 end;
function TDataFile.FldNameLnks(FldId:byte):string;
 var Fld:TFldRec;
 begin
  Fields^.GetRec(FldId,Fld);
  FldNameLnks:=
{$IFDEF Cyr}  
   ' '+ClearSp(RecStr(Fld.CntName,6))+
   ' ( '+LName+'.'+FldName(FldId)+')';
{$ENDIF}
{$IFDEF Lat}  
   'linked '+ClearSp(RecStr(Fld.CntName,6))+
   ' (by '+LName+'.'+FldName(FldId)+')';
{$ENDIF}
 end;
function TDataFile.LinkChois:byte;
 var P:PChoisList; i:byte;
 begin
  New(P,Init);
  for i:=0 to FLCnt-1 do with FLArr[i]
   do P^.Insert(DFArr[FileId]^.FldNameLnks(FldId));
  P^.SetCursor(LastFileLink);
{$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
{$IFDEF FPC} P^.Chois(i); {$ENDIF}
  LinkChois:=i;
 end;
function TDataFile.SelectFIndex:byte;
 var i,k:byte; Fld:TFldRec;
 begin
  k:=LastUsedIndex; i:=0;
  while (k=$FF) and (i<Fields^.Length) do begin
   Fields^.GetRec(i,Fld);
   if FldGetFlags(Fld,ffRootInd) then k:=i;
   Inc(i);
  end;
  SelectFIndex:=k;
 end;
procedure TDataFile.SelectIndex(var IndexId:byte);
 var P:PChoisList; i,k:byte; A:Small; Fld:TFldRec;
 begin
  New(P,Init);
  k:=0;
  for i:=0 to Fields^.Length-1 do begin
   Fields^.GetRec(i,Fld);
   if FldGetFlags(Fld,ffIndexed) then begin
    A[k]:=i;
    {$IFDEF Cyr}
    P^.Insert('  '+FldName(i));
    {$ENDIF} {$IFDEF Lat}
    P^.Insert('sorted by '+FldName(i));
    {$ENDIF}
    if i=IndexId then P^.SetCursor(k); Inc(k);
   end;
  end;
  A[k]:=$FF; P^.Insert(ErrStr(esUnSortOrder));
{$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
{$IFDEF FPC} P^.Chois(i); {$ENDIF}
  if i<=k then IndexId:=A[i];
 end;
function TDataFile.StdSummLine(ExFld:byte):string;
 var ps:PString; i,l,k:byte; Fld:TFldRec;
 begin
  New(ps); if CntSize=0 then ps^:='' else ps^:=Blank(CntSize)+VLChar;
  for i:=0 to Fields^.Length-1 do if i<>ExFld then begin
   Fields^.GetRec(i,Fld); l:=Fld.ShowSize;
   if l>0 then if FldGetFlags(Fld,ffCntSumm)
    then begin for k:=1 to l do ps^:=ps^+'?'; ps^:=ps^+VLChar end
    else ps^:=ps^+Blank(l)+VLChar;
  end;
  if FLCnt>0 then for i:=0 to FLCnt-1 do ps^:=ps^+Blank(6)+VLChar;
  StdSummLine:=ps^; Dispose(ps);
 end;
function TDataFile.StdHeaderLine(ExFld:byte; var SummLineExist:boolean):string;
 var ps,ps1:PString; i,l:byte; Fld:TFldRec; ns:string[9];
 begin
  New(ps); New(ps1);
  if CntSize=0
   then ps^:=''
   else begin
    ns:='No'; if CntSize>3 then ns:=ns+' ';
    LExpandStr(ns,CntSize,' '); ps^:=ns+VLChar;
   end;
  SummLineExist:=false;
  for i:=0 to Fields^.Length-1 do if i<>ExFld then begin
   Fields^.GetRec(i,Fld); l:=Fld.ShowSize;
   if l>0 then begin
    if FldGetFlags(Fld,ffCntSumm) then SummLineExist:=True;
    ps1^:=FldName(i);
    if length(ps1^)>l
     then Delete(ps1^,l+1,length(ps1^)-l)
     else while length(ps1^)<l do
      begin ps1^:=' '+ps1^; if length(ps1^)<l then ps1^:=ps1^+' ' end;
    ps^:=ps^+ps1^+VLChar;
   end;
  end;
  if FLCnt>0 then for i:=0 to FLCnt-1 do begin
   DFArr[FLArr[i].FileId]^.Fields^.GetRec(FLArr[i].FldId,Fld);
   ps^:=ps^+RecStr(Fld.CntName,6)+VLChar;
  end;
  StdHeaderLine:=ps^;
  Dispose(ps); Dispose(ps1);
 end;
procedure TDataFile.RecClear(var Rec);
 var i:byte; c:word; Fld:TFldRec; B:Block absolute Rec;
 begin
  c:=1; B[0]:=0;
  for i:=0 to Fields^.Length-1 do begin
   Fields^.GetRec(i,Fld); FldStdClear(Fld,B[c]); inc(c,Fld.Size);
  end;
 end;

{---------------------------------------------------------}

procedure ClearFileLinks;
 var i:byte;
 begin for i:=0 to 254 do if DFArr[i]<>Nil then DFArr[i]^.FLCnt:=0 end;
procedure AddFileLink(FlSors,FLDest,FieldId:byte);
 begin with DFArr[FlDest]^ do if FLCnt>FileLinkMax
  then begin LifeError(ErrStr(esManyLinksTo)+LName); Halt end
  else begin
   with FLArr[FLCnt] do begin FileId:=FlSors; FldId:=FieldId end;
   Inc(FLCnt);
  end;
 end;
procedure SetUserMode;
 var i,j:byte; Fld:TFldRec;
 begin
  ClearFileLinks;
  for i:=0 to 254 do if DFArr[i]<>Nil then begin
   with DFArr[i]^.Fields^ do if Length>0 then
    for j:=0 to Length-1 do begin
     GetRec(j,Fld);
     if Fld.FType=CFPntr then AddFileLink(i,Fld.FPtr,j);
    end;
   DFArr[i]^.LastUsedIndex:=$FF;
  end;
 end;

{---------------------------------------------------------}

var i:byte;

begin
 for i:=0 to 254 do DFArr[i]:=Nil;
end.
