unit cli_fwin;
interface

{$I options.pp}

uses
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 cli_data,
 Win_Def,
 Drivers;

type
 PFilesWindow = ^TFilesWindow;
 TFilesWindow = object (TBrouseWindow)
  constructor Init;
  function LastLine:longint; virtual;
  procedure ShowCnt; virtual;
  function Line(l:longint):string; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure CorrectEnable; virtual;
 end;

{------------------------------------------}

function SelectFileId(aFId:byte):byte;

implementation

uses
 Menu_cmd, TV_box, Cli_Recs, Str_def, TCP_Clnt,
 App, Objects, Views;

{------------------------------------------}

constructor TFilesWindow.Init;
 var R: TRect;
 begin
  R.Assign(0,3,16+17,21);
  inherited Init(bwFiles,Nil,R,5,12,ErrStr(esFilesClHead),false);
  MyCmdSet:=TCommandSet(RootCmdSet); HelpCtx:=hcFileList;
 end;
procedure TFilesWindow.ShowCnt;
 begin
  WriteStr(4,1,
   {$IFDEF Cir}'  :'{$ENDIF}
   {$IFDEF Lat}'File list:'{$ENDIF},2)
 end;
function TFilesWindow.Line(l:longint):string;
 var s:string;
 begin if DFArr[l]<>Nil
  then with DFArr[l]^ do begin
   Str(FilSize:8,s);
   Line:=' '+JustStr(LName,12)+' '+VLChar+
         ' '+JustStr(SName, 4)+' '+VLChar+s;
  end
  else Line:=BlankLine
 end;
function TFilesWindow.LastLine:longint; begin LastLine:=FileCount end;

procedure TFilesWindow.CorrectEnable;
 begin
  if WinCursor=LastLine 
   then DisableCommands(TCommandSet(RootCmdSet1));
 end;

procedure TFilesWindow.HandleEvent(var Event: TEvent);
 begin
  inherited HandleEvent(Event);
  case Event.What of
   evCommand:case Event.Command of
    cmBrouseDouble,cmUse:if WinCursor<LastLine then
     Message(Application,evBroadcast,cmUseFile,DFArr[WinCursor]);
    else Exit;
   end;
   else Exit;
  end;
  ClearEvent(Event);
 end;

{------------------------------------------------------}

function SelectFileId(aFId:byte):byte;
 var P:PChoisList; i:byte;
 begin
  New(P,Init);
  if FileCount>0 then for i:=0 to FileCount-1
   do P^.Insert(' '+DFArr[i]^.LName+' ');
  P^.SetCursor(aFId);
{$IFDEF Turbo} Dispose(P,Chois(i)); {$ENDIF}
{$IFDEF FPC} P^.Chois(i); {$ENDIF}
  SelectFileId:=i;
 end;

{------------------------------------------------------}

end.
