unit cli_info;
interface

{$I options.pp}

uses
 Date_lib, Common,
 tv_box, Views, Objects, Drivers;

type
 PCountWindow = ^TCountWindow;
 TCountWindow = object (TSWindow)
  OT:TimeRec; OM:longint; OD:DateRec; OC:byte;
  SrvState:TServerState;
  constructor Init;
  procedure DrawData; virtual;
  procedure Draw; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

procedure FreshCounter;

var PInfo:PCountWindow;

implementation

uses
 Crt,
 {$IFDEF Turbo} Skl_defs, Dos, SPX_Clnt, {$ENDIF}
 {$IFDEF FPC  } Sk_types, Linux, TCP_Clnt, {$ENDIF}
 Win_def, Menu_cmd, Str_Def,
 App;

{----------------------------------------------}

constructor TCountWindow.Init;
 var R:TRect;
 begin
  R.Assign(
   Desktop^.Size.X-40,Desktop^.Size.Y-6,
   Desktop^.Size.X,   Desktop^.Size.Y);
  inherited Init(R,
{$IFDEF Cir} '',wnNoNumber); {$ENDIF}
{$IFDEF Lat} 'SystemInfo',wnNoNumber); {$ENDIF}
  Palette:=wpBlueWindow;
  Flags:=Flags and ($FF xor (wfGrow+wfClose+wfZoom));
  Options := (Options or ofFirstClick) and ($FFFF xor ofSelectable);
  TimeClear(OT); DateClear(OD);
  OM:=-1; OC:=$FF;
  with SrvState do begin MemSt:=''; NetSt:='' end;
 end;
procedure TCountWindow.DrawData;
 var s:string;
 begin
{$IFDEF Cir}
  Str(OM,s); WriteStr(3,1,' = '+s+'   ',1);
  s:=' '+DateStr_2(OD)+',  '+TimeStr_1(OT);
  WriteStr(3,2,s,1);
  WriteStr(3,3,SrvState.MemSt,1);
  WriteStr(3,4,SrvState.NetSt,1);
{$ENDIF}
{$IFDEF Lat}
  Str(OM,s); WriteStr(3,1,'FreeMem = '+s+'   ',1);
  s:='Date '+DateStr_2(OD)+', time '+TimeStr_1(OT);
  WriteStr(3,2,s,1);
  WriteStr(3,3,SrvState.MemSt,1);
  WriteStr(3,4,SrvState.NetSt,1);
{$ENDIF}
 end;
procedure TCountWindow.Draw; begin inherited Draw; DrawData end;
procedure TCountWindow.HandleEvent(var Event: TEvent);
 var D:DateRec; T:TimeRec; h1,m1,s1,s0:word;
 begin
  inherited HandleEvent(Event);
  if Event.What=evBroadcast then if Event.Command=cmCountMsg then begin
   DateGetD(D); TimeGetT(T);
   if T.m<>OT.m then SendToServerSh(ncGetSrvState);
   if (not TimeEqu(T,OT)) or
      (not DateEqu(OD,D)) or
      (MemAvail<>OM) { or (FileCount<>OC)} then
    begin { OC:=FileCount;} OT:=T; OD:=D; OM:=MemAvail; DrawData end;
   ClearEvent(Event);
  end;
 end;

procedure FreshCounter;
 begin Message(PInfo,evBroadcast,cmCountMsg,Nil) end;

{----------------------------------------------}

end.