unit cli_tran;
{$I options.pp}
interface

uses
 Common;

function LoadRec(
 aFileId:byte; aRecId:longint; var R; aLock:boolean):TLoadResult;

function SaveRec(
 aFileId:byte; var aRecId:longint; var R; aOld,aUpdate:boolean):TSaveResult;

function ErasRec(
 aFileId:byte; aRecId,aReplId:longint):TErasResult;

implementation

uses
 cli_proc, cli_data, cli_recs,
 {$IFDEF Turbo} Skl_defs, {$ENDIF}
 {$IFDEF FPC  } Sk_types, {$ENDIF}
 tv_box, trace,
 App, Objects, Drivers, Views;

{-------------------------------------------------------------}

type
 PTranProcess  = ^TTranProcess;
 TTranProcess  = object (TLocalProcess)
  procedure Answer(cmd:byte; var Data); virtual;
 end;
 PTranRecWin = ^TTranRecWin;
 TTranRecWin = object (TSDialog)
  TR:TlpTranRec;
  PB:PBlock;
  PTP: PTranProcess;
  constructor Init(aTR:TlpTranRec;
   {aTran:byte; aFileId:byte; aRecId,aReplId:longint;}
   var Data
   {; aLock,aUpdate:boolean});
  procedure Draw; virtual;
  destructor Done; virtual;
 end;

procedure TTranProcess.Answer(cmd:byte; var Data);
 var
  PDF:PDataFile; Fld:TFldRec;
  PTRW : PTranRecWin absolute MyWin;
  aRLine :TlpRecLineA absolute Data;
  aTRA   :TlpTranRec  absolute Data;
 procedure StopTran;
  var Event:TEvent;
  begin
   with Event do begin
    What := evCommand;
    Command := cmCancel;
    InfoPtr := nil;
   end;
   PTRW^.PutEvent(Event);
  end;
 begin case cmd of
  lpTranRecA:with PTRW^ do begin
    TR:=aTRA;
    case TR.TranCase of
     TranLoad:if TR.LRes<>LoadSucess then StopTran;
     TranSave,TranEras:StopTran;
    end;
   end;
  lpRecLineA:with PTRW^ do with aRLine do begin
    PDF:=DFArr[TR.FileId]; PDF^.Fields^.GetRec(FldId,Fld);
    Move(Value,PB^[PDF^.FldPos(FldId)],Fld.Size);
    if FldId=PDF^.Fields^.Length-1 then StopTran;
   end;
 end end;

constructor TTranRecWin.Init(aTR:TlpTranRec; var Data);
 var R:TRect; Sucess:boolean; Tit:string[20];
  RLA:TlpRecLineA; Fld:TFldRec; i:byte;
 begin
  R.Assign(0,0,38,6); { R.Move(38,9); }
  case aTR.TranCase of
{$IFDEF Cir}
   TranLoad:Tit:='';
   TranSave:Tit:='  ';
   TranEras:Tit:='/';
{$ENDIF}
{$IFDEF Lat}
   TranLoad:Tit:='Locking';
   TranSave:Tit:='Save & unlock';
   TranEras:Tit:='Erasing/mixing';
{$ENDIF}
  end;
  inherited Init(R,Tit);
  Palette:=wpGrayWindow;
  Flags:=Flags and ($FF xor (wfGrow+wfZoom+wfMove));
  Options:=Options or ofCentered;
  PB:=addr(Data); TR:=aTR;
{
  with TR do begin
   FileId:=aFileId; RecId:=aRecId; TranCase:=aTran;
   case TranCase of
    TranLoad:Lock:=aLock;
    TranSave:begin Old:=aLock; UpdateOK:=aUpdate end;
    TranEras:ReplId:=aReplId;
   end;
  end;
}
  New(PTP,Init(@Self,Sucess)); DrawView;
  PTP^.Question(lpTranRecQ,TR,SizeOf(TR));
  with TR do if (TranCase=TranSave) and UpdateOK
   { Send record fields to server: }
   then with DFArr[FileId]^ do for i:=0 to Fields^.Length-1 do begin
    Fields^.GetRec(i,Fld);
    with RLA do begin FldId:=i; Move(PB^[FldPos(i)],Value,Fld.Size) end;
    PTP^.Question(lpRecLineA,RLA,SizeOf(RLA));
   end;
 end;
destructor TTranRecWin.Done;
 begin
  Dispose(PTP,Done);
  inherited Done;
 end;
procedure TTranRecWin.Draw;
 var s1,s2:string[20];
 begin
  inherited Draw;
  Str(TR.FileId,s1); Str(TR.RecId,s2);
  case TR.TranCase of
{$IFDEF Cir}
   TranLoad:WriteStr(3,2,'  ...',1);
   TranSave:WriteStr(3,2,'  ...',1);
   TranEras:WriteStr(3,2,'  ...',1);
{$ENDIF}
{$IFDEF Lat}
   TranLoad:WriteStr(3,2,'Loading record ...',1);
   TranSave:WriteStr(3,2,'Saving record ...',1);
   TranEras:WriteStr(3,2,'Erasing record ...',1);
{$ENDIF}
  end;
  WriteStr(3,3,'File: '+s1+'  Rec: '+s2,1);
 end;

function LoadRec(
 aFileId:byte; aRecId:longint; var R; aLock:boolean):TLoadResult;
 var PTRW:PTranRecWin; TR:TlpTranRec;
 begin
  with TR do begin
   FileId:=aFileId; RecId:=aRecId;
   TranCase:=TranLoad; Lock:=aLock;
  end;
  New(PTRW,Init(TR,R));
  Desktop^.ExecView(PTRW);
  LoadRec:=PTRW^.TR.LRes;
  Dispose(PTRW,Done);
 end;

{-------------------------------------------------------------}

function SaveRec(
 aFileId:byte; var aRecId:longint; var R; aOld,aUpdate:boolean):TSaveResult;
 var PTRW:PTranRecWin; TR:TlpTranRec;
 begin
  with TR do begin
   FileId:=aFileId; RecId:=aRecId;
   TranCase:=TranSave; Old:=aOld; UpdateOK:=aUpdate;
  end;
  { WrLogStr('SaveRec begin ...'); }
  New(PTRW,Init(TR,R));
  Desktop^.ExecView(PTRW);
  with PTRW^.TR do begin SaveRec:=SRes; aRecId:=RecId end;
  Dispose(PTRW,Done);
  { WrLogStr('SaveRec done ...'); }
 end;

{-------------------------------------------------------------}

function ErasRec(
 aFileId:byte; aRecId,aReplId:longint):TErasResult;
 var PTRW:PTranRecWin; TR:TlpTranRec; Dummy:byte;
 begin
  with TR do begin
   FileId:=aFileId; RecId:=aRecId;
   TranCase:=TranEras; ReplId:=aReplId;
  end;
  New(PTRW,Init(TR,Dummy));
  Desktop^.ExecView(PTRW);
  ErasRec:=PTRW^.TR.ERes;
  Dispose(PTRW,Done);
 end;

{-------------------------------------------------------------}

end.

