unit tcp_clnt;
interface

{$I options.pp}

uses
 common, tcp_def;

const
 Server:PNetLink = Nil;
 FileCount:byte   = 0;

procedure Connect;
procedure ExitLink;
procedure ExitProg(s:string);
procedure SendToServer(cmd:byte; var R; Size:word);
procedure SendToServerSh(cmd:byte);
procedure WaitFromServer(cmd:byte; var Buf:TNetBuf);

implementation

uses
 sk_types, inet,
 cli_recs, cli_info, cli_data, cli_app,
 Win_def, Str_def, tv_box,
 trace, App, Views, Drivers;

procedure ExitProg(s:string);
 var Event:TEvent;
 begin
  if Server<>Nil then Server^.Used:=false;
  LifeError('Exit: '+s);
  with Event do begin What:=evCommand; Command:=cmQuit; InfoPtr:=Nil end;
  Application^.PutEvent(Event);
 end;
procedure ExitLink;
 begin ExitProg('NetLink was terminated') end;

procedure SendToServer(cmd:byte; var R; Size:word);
 begin if Server<>Nil then with Server^ do
  if Used then NetMessage(cmd,R,Size) { else ExitLink }
 end;
procedure SendToServerSh(cmd:byte);
 var Dummy:byte; begin SendToServer(cmd,Dummy,1) end;
procedure WaitFromServer(cmd:byte; var Buf:TNetBuf);
 var Cmd0:byte;
 begin
  with Server^ do repeat
   if Used then begin
    NetRead(Cmd0,Buf);
    if Cmd0<>cmd then CliAction(Cmd0,Buf);
   end;
  until (not Used) or (Cmd0=cmd);
 end;

procedure GetStructure;
 var i:byte; Buf:TNetBuf; FS:TFileStructure absolute Buf;
 begin
{ with PInfo^ do WriteStr(3,3,'Files=$'+HexByte(FileCount)+' ',1); }
  with SRDBApp do begin New(FileWindow,Init); InsertWindow(FileWindow) end;
  if FileCount>0 then for i:=0 to FileCount-1 do if Server^.Used
   then SendToServer(ncGvMeFilStruct,i,1);
  if FileCount>0 then for i:=0 to FileCount-1 do if Server^.Used then begin
   WaitFromServer(ncFileStructure,Buf); New(DFArr[i],Open(FS));
{  SRDBApp.FileWindow^.SetWCursor(i); }
  end;
  SRDBApp.FileWindow^.SetWCursor(0);
  if Server^.Used then SendToServerSh(ncIAmClient) else ExitLink;
 end;

procedure Connect;
 var HostName:string; TH:THost; OK:boolean;
 var cmd:byte; Buf:TNetBuf; IAmServer:TIAmServer absolute Buf;
 begin
  {HostName:='127.0.0.1';}
  repeat
    HostName:='LocalHost'; OK:=False;
    if LogFileEnable then WrLogStr('Default host is '+HostName);
    EditSomeString('Enter IP-address or host name', HostName , 30);
    if LogFileEnable then WrLogStr('Modified host = '+HostName);
    with TH do begin
     NameLookup(HostName);
     HostName:=IPString; OK:=LastError=0;
     Done;
    end;
    if not OK then LifeError('DNS lookup failure, enter proper hostname');
  until OK;
  New(Server, Init(HostName));
  with Server^ do begin
   repeat until (not Used) or NetListen(cmd,Buf);
   if Used and (cmd=ncIAmServer) then begin
    if LogFileEnable then WrLogStr(IAmServer.Name+' connected');
    FileCount:=IAmServer.FCnt;
    GetStructure;
   end else ExitProg('No active SRDB server found at this IP address');
  end
 end;

end.
