unit tcp_def;
interface

{$I options.pp}

uses
 common;

type
 PNetLink = ^TNetLink;
 TNetLink = object (TSomeLink)
  Server:longint;
  constructor Init(aHost:string);
  destructor Done; virtual;
  procedure NetMessage(cmd:byte; var Data; DataSize:word); virtual;
  function  NetListen(var cmd:byte; var Buf:TNetBuf):boolean; virtual;
 end;

implementation

uses
 Trace, sk_types, TCP_Clnt, netctrl, Linux, tv_box;

const
 Err_TryAgain = 11;

constructor TNetLink.Init(aHost:string);
 var SA_server:TSockAddr_inet; i:byte; s:string;
 begin
  Used:=False; 
  server:=socket(AF_INET,SOCK_STREAM, 6 {0});
  if server<0 then ExitProg('socket error');
  with SA_Server do begin
   Domain:=AF_INET; Port:=SwapWord(ServerPort);
{
   write('Enter IP address (0.0.0.0 for local host): '); readln(msg);
}
   if not inet_adr_to_num(aHost,Host) then ExitProg('bad IP address');
  end;
  s:='SA_Server=$ ';
  for i:=0 to 15 do s:=s+HexByte(PBlock(@SA_Server)^[i])+' ';
  if LogFileEnable then begin
   WrLogStr(s);
   WrLogStr('Waiting for connection ...');
  end;
  if connect(server,SA_Server,SizeOf(SA_server))<>0
   then { LifeError('connect error') } else Used:=True;
  if LogFileEnable then if Used 
   then WrLogStr('Succesful connection ...')
   else WrLogStr('Connection failed ...');
{ }
  if _fcntl(server,F_SetFl,Open_NonBlock)=-1 then ExitProg('fcntl error');
{ }
 end;
destructor TNetLink.Done;
 begin
  { fdClose(server); > other case to do the same }
  Used:=False;
  if 0>shutdown(server,2)
   then { LifeError('shutdown error') }
   else LifeError('Shuting down the connection ...');
 end;

function BufStr(var Buf):string;
 var i:byte; s:string; P:PBlock;
 begin
  P:=@Buf; 
  s:=HexByte(P^[0])+' '+HexByte(P^[1])+' '+
     HexByte(P^[2])+' '+HexByte(P^[3])+' -> ';
  for i:=0 to 32 do if P^[i]<32 
   then s:=s+'.' else s:=s+char(P^[i]);
  BufStr:=s; 
 end;

procedure TNetLink.NetMessage(cmd:byte; var Data; DataSize:word);
 var P:PBlock;
 begin if Used then begin
  GetMem(P,DataSize+3);
  Move(DataSize,P^,SizeOf(word));
  Move(cmd,P^[2],1);
  Move(Data,P^[3],DataSize);
  fdWrite(Server,P^,DataSize+3);
  FreeMem(P,DataSize+3);
  if LogFileEnable then 
   WrLogStr('Out: $'+HexByte(cmd)+' data: '+BufStr(Data));
 end end;

function TNetLink.NetListen(var cmd:byte; var Buf:TNetBuf):boolean;
 var DataSize:word; ActRd:longint;
 begin
  ActRd:=fdRead(Server,DataSize,2);
  if 2=ActRd then begin
   NetListen:=True;
   ActRd:=fdRead(Server,cmd,1);
   if ActRd<>1
    then ExitProg('Cant read cmd')
    else begin
     ActRd:=fdRead(Server,Buf,DataSize);
     if ActRd<>DataSize then ExitProg('Cant read Buf');
     if LogFileEnable then 
      WrLogStr('InLen=$'+HexWord(DataSize)+
               ' Cmd=$'+HexByte(cmd)+
               ' Buffer=$ '+BufStr(Buf));
    end;
  end else begin
   NetListen:=false;
   if (ActRd<=0) and (LinuxError<>Err_TryAgain)
    then begin Used:=false; ExitLink end
    else if ActRd=1 then ExitProg('1 byte read from DataSize');
  end;
 end;

end.
