unit common;

{$I options.pp}

interface

uses
 {$IFDEF Turbo} Skl_defs {$ENDIF}
 {$IFDEF Linux} Sk_types {$ENDIF};

const
 LogFileEnable:boolean = False;
 ServerPort = 5812;
 { MaxNetBufSize: }
 NetBufSize = 512;
 { Server cmds: }
 ncIAmServer      =   0;
 ncFileStructure  =   1;
 ncFieldStructur  =   2;
 ncServerState    =   3;
 ncLocProcAnswer  =   4;
 ncModifyRecord   =   5;
 { Client cmds: }
 ncGvMeFilStruct  = 100;
 ncIAmClient      = 101;
 ncGetSrvState    = 102;
 ncLocProcQuest   = 103;
 { SPX cmds: }
 ncLinkTerminated = 254;
 { Local Process commands: }
 lpLimits    = 0;
 lpDataLines = 1;
 lpDataLineA = 2;
 lpRecLines  = 3;
 lpRecLineA  = 4;
 lpTranRecQ  = 5;
 lpTranRecA  = 6;
 lpPtrLineQ  = 7;
 lpPtrLineA  = 8;
 { Tranzaction cases: }
 TranLoad = 0;
 TranSave = 1;
 TranEras = 2;

type
 TNetBuf = array[0..NetBufSize-1] of byte;
 TStr80  = string[80];
 TServerName = TStr80;
 LongFName = string[12];
 ShortFName = string[4];
 TDFNames = record
  FName:SmallFName;
  LName:LongFName;
  SName:ShortFName;
  Status:byte; { 0 - norm, 1 - temp }
  CntSize:byte; { Column for rec counter }
 end;

type
 TLoadResult = (LoadSucess,Protected,Erased);
 TSaveResult = (SaveSucess,UniqueErr);
 TErasResult = (ErasSucess,EProtected,EErased,LnkInUse);
 TModifyCase = (EditRec,NewRec,EraseRec);
 TIAmServer = record
  Name:TServerName;
  FCnt:byte;
 end;
 TFileStructure = record
  DFN:TDFNames;
  FldCnt:byte;
  FilSize:longint;
 end;
 TServerState = record
  MemSt, NetSt: TStr80;
 end;
 PModifyRecord = ^TModifyRecord;
 TModifyRecord = record
  FileId:byte;
  RecId:longint;
  MCase:TModifyCase;
 end;
 {----------------------}
 { Local Process head:  }
 TCliWinHead =  record
  Port:byte; { Client process Id }
  SesId:word; { Unique sesion Id for this process }
  PCmd:byte; { Process local command }
 end;
 { Local Process tails: }
 PlpLimits = ^TlpLimits;
 TlpLimits = record
  FileId, IndexId:byte; Ltd:boolean; Limits:Small;
  CurStart,CurEnd:Longint;
  WinInd, RecInd:longint; EvalWinInd:boolean;
  LimitStr:TStr80;
 end;
 PlpDataLines = ^TlpDataLines;
 TlpDataLines = record
  FileId, IndexId:byte;
  CurStart,CurEnd,WinStart:Longint;
  WinMax:byte; aExFld:byte;
  SesId:word;
 end;
 PlpDataLineA = ^TlpDataLineA;
 TlpDataLineA = record
  SesId:word;
  WinDY:byte;
  RecInd:longint;
  BrStr:TStr80;
 end;
 PlpRecLines = ^TlpRecLines;
 TlpRecLines = record
  SesId:word; SubProcess:byte;
  FileId:byte; RecId:longint;
 end;
 PlpRecLineA = ^TlpRecLineA;
 TlpRecLineA = record
  SesId:word; SubProcess:byte;
  FldId:byte;
 case FldIsPntr:boolean of
  true:(Pntr:longint; BrStr:TStr80);
  false:(Value:Small);
 end;
 PlpPtrLineQ = ^TlpPtrLineQ;
 TlpPtrLineQ = record
  SesId:word; FileId:byte; RecId:longint;
 end; 
 PlpPtrLineA = ^TlpPtrLineA;
 TlpPtrLineA = record
  SesId:word; BrStr:TStr80;
 end;
 PlpTranRec = ^TlpTranRec;
 TlpTranRec = record
  FileId:byte; RecId:longint; TranCase:byte;
  case byte of
   TranLoad:(Lock:boolean;          LRes:TLoadResult);
   TranSave:(Old, UpdateOK:boolean; SRes:TSaveResult);
   TranEras:(ReplId:longint;        ERes:TErasResult);
 end;
 {----------------------}

type
 PSomeLink = ^TSomeLink;
 TSomeLink = object
  Used:boolean;
  procedure NetMessage(cmd:byte; var Data; DataSize:word); virtual;
  function NetListen(var cmd:byte; var Buf:TNetBuf):boolean; virtual;
  function NetRead(var cmd:byte; var Buf:TNetBuf):boolean; virtual;
  function Exists:boolean; virtual;
  destructor Done; virtual;
 end;

function LPCmdName(cmd:byte):string;
function HexByte(i:byte):string;
function HexWord(i:word):string;
function HexLong(i:longint):string;
function SwapWord(x:word):word;

implementation

procedure TSomeLink.NetMessage(cmd:byte; var Data; DataSize:word);
 begin end;
function TSomeLink.NetListen(var cmd:byte; var Buf:TNetBuf):boolean;
 begin end;
function TSomeLink.NetRead(var cmd:byte; var Buf:TNetBuf):boolean;
 begin
  NetRead:=True;
  while Exists and (not NetListen(cmd,Buf)) do;
  if not Exists then begin NetRead:=False; Done end;
 end;
function TSomeLink.Exists:boolean; begin Exists:=Used end;
destructor TSomeLink.Done; begin Used:=False end;

function LPCmdName(cmd:byte):string;
 begin
  LPCmdName:='unknown';
  case cmd of
   lpLimits:LPCmdName:=   'Limits ';
   lpDataLines:LPCmdName:='BrLines';
   lpDataLineA:LPCmdName:='BrLine ';
   lpRecLines:LPCmdName:= 'RecFlds';
   lpRecLineA:LPCmdName:= 'RecFld ';
   lpPtrLineQ:LPCmdName:= 'GetPLin';
   lpPtrLineA:LPCmdName:= 'BrPtrLi';
   lpTranRecQ:LPCmdName:= 'TranRec';
   lpTranRecA:LPCmdName:= 'TranInf';
  end 
 end;

function HexByte(i:byte):string;
 const hexDig='0123456789ABCDEF';
 begin hexbyte:=hexDig[1 + i shr 4] + hexDig[1 + i and $0f] end;
function HexWord(i:word):string;
 begin HexWord:=HexByte(Hi(i))+HexByte(lo(i)) end;
function HexLong(i:longint):string;
 var w:array[0..1] of word absolute i;
 begin HexLong:=HexWord(w[1])+HexWord(w[0]) end;
function SwapWord(x:word):word;
 begin SwapWord:=((x and $ff) shl 8) + (x shr 8) end;

end.
