unit lists;

{---------------------------------------------------------------------

(C) by Skelet (Georgi Georgiev) in terms of GNU General Public License

This is a unit for some list manipulations.
Must be compiled by fpk-pascal compiler, version 0.99, under Linux OS.

---------------------------------------------------------------------}

interface

type
 PTailNode = ^TTailNode;
 TTailNode = object
  Prev, Next:PTailNode;
  constructor Init;
  destructor Done; virtual;
 end;
 PTail = ^TTail;
 TTail = object
  Cursor:PTailNode;
  constructor Init;
  procedure InsertNode(El:PTailNode);
  procedure DeleteNode;
  procedure RollNode;
 end;

implementation

constructor TTailNode.Init; begin end;
destructor TTailNode.Done; begin end;

constructor TTail.Init; begin Cursor:=Nil end;
procedure TTail.InsertNode(El:PTailNode);
 begin
  if Cursor=Nil
   then begin El^.Prev:=El; El^.Next:=El end
   else begin
    El^.Prev:=Cursor; El^.Next:=Cursor^.Next;
    El^.Next^.Prev:=El; El^.Prev^.Next:=El;
   end;
  Cursor:=El;
 end;
procedure TTail.DeleteNode;
 var Old,Prev:PTailNode;
 begin if Cursor<>Nil then begin
  Old:=Cursor; Prev:=Old^.Prev;
  if Prev=Cursor
   then Cursor:=Nil
   else begin
    Cursor:=Old^.Next;
    Prev^.Next:=Cursor;
    Cursor^.Prev:=Prev
   end;
   Dispose(Old,Done);
 end end;
procedure TTail.RollNode;
 begin if Cursor<>Nil then Cursor:=Cursor^.Next end;

end.
