unit sr_conn;
{$I options.pp}
interface

uses lists, sr_data, common, sk_types;

const
{ LogFileEnable:boolean = False;
}
 MaxClients = 16;

type
 PCliBuf = ^TCliBuf;
 TCliBuf = object
  Buf:TNetBuf; AnsSize:word; PDF:PDataFile; PB:PBlock;
  constructor Init(var aBuf:TNetBuf; aAnsSize:word; aPDF:PDataFile);
  destructor Done;
 end;
 PClientLink = ^TClientLink;
 TClientLink = object (TTailNode)
  Client:longint;
  Connected:boolean;
  CliNo:byte;
  State:byte;
  CliBuf:PCliBuf;
  procedure Registrate;
  function Talk:boolean;
  procedure NetMessage(cmd:byte; var Data; DataSize:word); virtual;
  function NetListen(var cmd:byte; var Buf:TNetBuf):boolean; virtual;
  procedure NetSend(cmd:byte; var Data; DataSize:word);
  procedure SendToAll(cmd:byte; var Data; DataSize:word);
 end;

procedure LogInit;

procedure ShowError(s:string);

implementation

uses
 { Crt, Dos, Skl_defs, Files, }
 { Sk_types, Common, }
 { SPX_Def, }
 sr_recs, { sr_data,}  sr_eval;

{----------------------------------------------------------------------}

var
 LogFile:text;
 IAmServer:TIAmServer;

type TStr8 = string[8];

procedure ShowDialog(HStr:TStr8; Cmd:byte; Buf:TNetBuf);
 var
  Id:byte absolute Buf;
  LocHead:TCliWinHead absolute Buf;
  FS:TFileStructure   absolute Buf;
  FldS:TFldRec        absolute Buf;
  MR:TModifyRecord    absolute Buf;
  PQA:pointer;
  PLim:PlpLimits    absolute PQA;
  PDLn:PlpDataLines absolute PQA;
  PLin:PlpDataLineA absolute PQA;
  PRLn:PlpRecLines  absolute PQA;
  PRLin:PlpRecLineA absolute PQA;
  PPLinQ:PlpPtrLineQ absolute PQA;
  PPLinA:PlpPtrLineA absolute PQA;
  PTran:PlpTranRec  absolute PQA;
 var i:byte;
 procedure WLog(s:string); begin Write(LogFile,s) end;
 procedure CmdName(CmdStr:string); 
  begin 
   WLog(CmdStr+' ') 
  end;
 function ChrByte(c:byte):string;
  begin if c<32 then ChrByte:='.' else ChrByte:=chr(c) end;
 begin
  PQA:=addr(Buf[SizeOf(LocHead)]);
  Append(LogFile);
  WLog(HStr+' ');
  case cmd of
   ncLinkTerminated:CmdName('Terminate Link');
   { --- Server --- }
   ncIAmServer:
     CmdName('I am '+IAmServer.Name+'; $'+HexByte(FileCount)+' open files');
   ncFileStructure:with FS do CmdName(
     'File "'+DFN.LName+'" contains $'+HexByte(FldCnt)+
     ' fields and $'+HexLong(FilSize)+' records.');
   ncFieldStructur:CmdName('Field '+VLChar+FieldStr(FldS)+VLChar);
   ncServerState:CmdName('ServerState');
   ncModifyRecord:with MR do begin
     CmdName('File=$'+HexByte(FileId)+' RecId=$'+HexLong(RecId)+': ');
     case MCase of
      EditRec: WLog(' Modify');
      NewRec:  WLog(' NewRecord');
      EraseRec:WLog(' Erase');
     end;
    end;
   { --- Client --- }
   ncIAmClient:CmdName('IAmClient');
   ncGvMeFilStruct:CmdName('Give me structure for file '+HexByte(Id));
   ncGetSrvState:CmdName('GetServerState');
   { --- Both local proc --- }
   ncLocProcQuest,ncLocProcAnswer:begin
     { CmdName('LP'); }
     with LocHead do begin
      WLog( { Port/Sesion; lpCommand }
       'P/S=$'+HexByte(Port)+'/'+HexWord(SesId)+' '+LPCmdName(PCmd)+': ');
      case PCmd of
       lpLimits:with PLim^ do begin
         WLog('File=$'+HexByte(FileId)+' Index=$'+HexByte(IndexId)+' ');
         if Ltd
          then WLog('Limited')
          else WLog('Unlimited');
         WLog(' Start='+HexLong(CurStart)+' End='+HexLong(CurEnd));
         WLog(' Cursor='+HexLong(WinInd)+' RecInd='+HexLong(RecInd));
{
         if EvalWinInd
          then WLog(' EvalWinPos')
          else WLog(' EvalRecInd');
         WLog(' LimStr=');
         for i:=1 to 40 do WLog(ChrByte(ord(LimitStr[i])));
}     
        end;
       lpDataLines:with PDLn^ do begin
         WLog('File=$'+HexByte(FileId)+' Index=$'+HexByte(IndexId));
         WLog(' Start='+HexLong(CurStart)+' End='+HexLong(CurEnd));
         WLog(' WinStart='+HexLong(WinStart)+' WinMax='+HexByte(WinMax));
         WLog(' ExFld='+HexByte(aExFld)+' LS='+HexWord(SesId));
        end;
       lpDataLineA:with PLin^ do WLog(
          'LS='+HexWord(SesId)+' DY=$'+HexByte(WinDY)+
          ' Rec=$'+HexLong(RecInd)+' '+VLChar+BrStr+VLChar);
       lpRecLines:with PRLn^ do begin
         WLog('LS/SP='+HexWord(SesId)+'/'+HexByte(SubProcess));
         WLog(' File=$'+HexByte(FileId)+' Rec=$'+HexLong(RecId));
        end;
       lpRecLineA:with PRLin^ do begin
         WLog('LS/SP='+HexWord(SesId)+'/'+HexByte(SubProcess)+' ');
         for i:=0 to 30 do WLog(ChrByte(Value[i]));
        end;
       lpPtrLineQ:with PPLinQ^ do begin
         WLog('LS='+HexWord(SesId));
         WLog(' File=$'+HexByte(FileId)+' Rec=$'+HexLong(RecId));
        end;
       lpPtrLineA:with PPLinA^ do begin
         WLog('LS='+HexWord(SesId)+' '+BrStr);
        end;
       lpTranRecQ,lpTranRecA:with PTran^ do begin
         WLog('File/Rec=$'+HexByte(FileId)+'/'+HexLong(RecId));
         if PCmd=lpTranRecQ then case TranCase of
          TranLoad:if Lock then WLog(' Lock_&_load') else WLog(' Copy');
          TranSave:begin
            if Old then WLog(' Old') else WLog(' New');
            if UpdateOK then WLog(' Update') else WLog(' Release');
           end;
          TranEras:WLog(' Erase/Mix ReplId=$'+HexLong(ReplId));
         end;
         if PCmd=lpTranRecA then begin
          WLog(' Result: ');
          case TranCase of
           TranLoad:case LRes of
             LoadSucess:WLog('LoadSucess');
             Protected:WLog('Protected');
             Erased:WLog('Erased');
            end;
           TranSave:case SRes of
             SaveSucess:WLog('SaveSucess');
             UniqueErr: WLog('UniqueErr');
            end;
           TranEras:case ERes of
             ErasSucess:WLog('ErasSucess');
             EProtected:WLog('Protected');
             EErased:WLog('Erased');
             LnkInUse:WLog('LinkRecInUse');
            end;
          end;
         end;
        end;
      end;
     end;
    end;
  end;
  Writeln(LogFile); Close(LogFile);
 end;
procedure ShowError(s:string);
 begin if LogFileEnable then begin
  Append(LogFile); Writeln(LogFile,s); Close(LogFile) end end;

{----------------------------------------------------------------------}

const
 clNone = 0;
 clRgst = 1;
 clNorm = 2;

(*
type
 PMessLink = ^TMessLink;
 TMessLink = record
  Next:PMessLink;
  aCmd:byte;
  aData:Pointer;
  aSize:word;
 end;

var
 MaxCon:word; Brd:TBroadcast;
 Clients:array[0..MaxClients-1] of ClientLink;

procedure SendToAll(cmd:byte; var Data; DataSize:word);
 var i:byte;
 procedure SendTo(CL:ClientLink);
  begin with CL do if State=clNorm then NetSend(cmd,Data,DataSize) end;
 begin
  if NetExists then for i:=0 to MaxClients-1 do SendTo(Clients[i]);
 end;
*)

constructor TCliBuf.Init(
 var aBuf:TNetBuf; aAnsSize:word; aPDF:PDataFile);
 begin
  Buf:=aBuf; AnsSize:=aAnsSize; PDF:=aPDF;
  GetMem(PB,PDF^.RecSize); PB^[0]:=0;
 end;
destructor TCliBuf.Done;
 begin
  FreeMem(PB,PDF^.RecSize);
 end;

procedure MyAction(var CL:TClientLink; cmd:byte; var Buf:TNetBuf);
 procedure STranDone(UpdOK:boolean);
  var
   PQA:pointer; PTran:PlpTranRec absolute PQA; OldId:longint;
   TMR:TModifyRecord;
  begin with CL do begin
   PQA:=addr(CliBuf^.Buf[SizeOf(TCliWinHead)]);
   OldId:=PTran^.RecId;
   if UpdOK then with PTran^ do { update record }
    if CliBuf^.PDF^.RecUpdate(RecId,CliBuf^.PB^,Old)
     then SRes:=SaveSucess else SRes:=UniqueErr;
   if PTran^.Old then CliBuf^.PDF^.RecProtList.Del(OldId); { unprotect }
   NetSend(ncLocProcAnswer,CliBuf^.Buf,CliBuf^.AnsSize);
   if UpdOK then with PTran^ do if SRes=SaveSucess then begin
    TMR.FileId:=FileId; TMR.RecId:=RecId;
    if Old then TMR.MCase:=EditRec else TMR.MCase:=NewRec;
    SendToAll(ncModifyRecord,TMR,SizeOf(TMR));
   end;
   Dispose(CliBuf,Done);
  end end;
 var
  Id:byte absolute Buf;
  LocHead:TCliWinHead absolute Buf;
 procedure SendAnswer;
  var
   AnsSize:word; PQA:pointer;
   PLim:PlpLimits absolute PQA;
   PDLn:PlpDataLines absolute PQA;
   PLin:PlpDataLineA absolute PQA;
   PRLn:PlpRecLines  absolute PQA;
   PRLin:PlpRecLineA absolute PQA;
   PPLinQ:PlpPtrLineQ absolute PQA;
   PPLinA:PlpPtrLineA absolute PQA;
   PTran:PlpTranRec  absolute PQA;
  procedure SendAns0;
   begin CL.NetSend(ncLocProcAnswer,Buf,AnsSize) end;
  procedure SendDataLines;
   var DL:TlpDataLines; i:byte;
   begin
    DL:=PDLn^; inc(AnsSize,SizeOf(TlpDataLineA));
    LocHead.PCmd:=lpDataLineA;
    for i:=0 to DL.WinMax-1 do if i+DL.CurStart+DL.WinStart<=DL.CurEnd
     then begin SetBrLine(DL,PLin^,i); SendAns0 end;
   end;
  procedure SendPtrLine;
   var FId:byte; Ind:Longint;
   begin
    FId:=PPLinQ^.FileId; Ind:=PPLinQ^.RecId;
    inc(AnsSize,SizeOf(TlpPtrLineA));
    LocHead.PCmd:=lpPtrLineA;
    PPLinA^.BrStr:=Copy(DFArr[FId]^.StdPtrLine(Ind,4),1,80);
    SendAns0;
   end;
  procedure SendRecLines;
   var
    RL:TlpRecLines; i:byte; PDF:PDataFile;
    PB:PBlock; c:word; Fld:TFldRec;
   begin
    RL:=PRLn^; inc(AnsSize,SizeOf(TlpRecLineA));
    LocHead.PCmd:=lpRecLineA; PDF:=DFArr[RL.FileId];
    with PDF^ do begin
     GetMem(PB,RecSize);
     Data^.GetRec(RL.RecId,PB^); c:=1;
     if PB^[0]<>$FF then for i:=0 to Fields^.Length-1 do begin
      PRLin^.FldId:=i; Fields^.GetRec(i,Fld);
      Move(PB^[c],PRLin^.Value,Fld.Size);
      if Fld.FType=cfPntr then PRLin^.BrStr:=
       Copy(DFArr[Fld.FPtr]^.StdPtrLine(PRLin^.Pntr,4),1,80);
      SendAns0; Inc(c,Fld.Size);
     end;
     FreeMem(PB,RecSize);
    end;
   end;
  procedure SendTranRecA;
   var TRQ:TlpTranRec; PDF:PDataFile;
   procedure LTran;
    var OK:boolean;
    begin
     OK:=True;
     if TRQ.Lock then OK:=PDF^.RecProtList.Add(TRQ.RecId); { protect ! }
     with PTran^ do if OK
      then if PDF^.RecExists(TRQ.RecId) then LRes:=LoadSucess else LRes:=Erased
      else LRes:=Protected;
     SendAns0;
     if PTran^.LRes=LoadSucess then begin
      dec(AnsSize,SizeOf(TRQ));
      with PRLn^ do begin FileId:=TRQ.FileId; RecId:=TRQ.RecId end;
      SendRecLines;
     end;
    end;
   procedure STranInit;
    begin
     PTran^.SRes:=SaveSucess;
     New(CL.CliBuf,Init(Buf,AnsSize,PDF));
     if TRQ.UpdateOK
      then { first load the record }
      else STranDone(False);
    end;
   procedure ETran;
    var TMR:TModifyRecord;
    begin
     with PTran^ do ERes:=PDF^.RecErase(RecId,ReplId);
     SendAns0;
     with PTran^ do if ERes=ErasSucess then begin
      TMR.FileId:=FileId; TMR.RecId:=RecId; TMR.MCase:=EraseRec;
      CL.SendToAll(ncModifyRecord,TMR,SizeOf(TMR));
     end;
    end;
   begin
    TRQ:=PTran^; inc(AnsSize,SizeOf(TRQ));
    LocHead.PCmd:=lpTranRecA; PDF:=DFArr[TRQ.FileId];
    case TRQ.TranCase of
     TranLoad:LTran;
     TranSave:STranInit;
     TranEras:ETran;
    end;
   end;
  procedure FillCliBuf;
   var Fld:TFldRec;
   begin with CL.CliBuf^ do with PRLin^ do begin
    PDF^.Fields^.GetRec(FldId,Fld);
    Move(Value,PB^[PDF^.FldPos(FldId)],Fld.Size);
    if PDF^.Fields^.Length=FldId+1 then STranDone(True);
   end end;
  begin
   AnsSize:=SizeOf(LocHead); PQA:=addr(Buf[AnsSize]);
   case LocHead.PCmd of
    lpLimits:begin
      inc(AnsSize,SizeOf(TlpLimits));
      SetLimits(PLim^); 
      SendAns0;
     end;
    lpDataLines:SendDataLines;
    lpRecLines:SendRecLines;
    lpRecLineA:FillCliBuf;
    lpPtrLineQ:SendPtrLine;
    lpTranRecQ:SendTranRecA;
   end;
  end;
 procedure SendInfo;
  var Info:TServerState;
  begin
   with Info do begin
{
    NetSt:=StatStr;
    Str(MemAvail,MemSt); MemSt:='Mem: '+MemSt+' ';
    if NetExists
     then MemSt:=MemSt+'IPX/SPX conn'
     else MemSt:=MemSt+'Local link';
}     
    NetSt:='SRDB daemon Ver 0.5 for Linux';
    MemSt:='(c) Skelet, 1998 in terms of GNU GPL';
   end;
   CL.NetSend(ncServerState,Info,SizeOf(Info));
  end;
 procedure SendStruct;
  var i:byte; FS:TFileStructure; Fld:TFldRec; PDF:PDataFile;
  begin
   PDF:=DFArr[Id];
   with FS do begin
{
    with DFN do begin
     FName:=PDF^.FName;
     ......
    end;
}   
    Move(PDF^.FName,DFN,SizeOf(DFN));
    FldCnt:=PDF^.Fields^.Length;
    FilSize:=PDF^.Data^.Length;
   end;
   CL.NetSend(ncFileStructure,FS,SizeOf(FS));
   if FS.FldCnt>0 then for i:=0 to FS.FldCnt-1 do begin
    PDF^.Fields^.GetRec(i,Fld);
    CL.NetSend(ncFieldStructur,Fld,SizeOf(Fld));
   end;
  end;
 begin
  if LogFileEnable then ShowDialog('Cli_'+HexByte(CL.CliNo),cmd,Buf);
  with CL do case cmd of
   ncIAmClient:begin State:=clNorm; SendInfo end;
   ncGvMeFilStruct:SendStruct;
   ncGetSrvState:SendInfo;
   ncLocProcQuest:SendAnswer;
  end;
 end;

function TClientLink.Talk:boolean;
 var cmd:byte; Buf:TNetBuf;
 begin
  Talk:=False;
  if Connected
   then if NetListen(cmd,Buf)
    then begin MyAction(Self,cmd,Buf); Talk:=True end
    else { Used, but not Listen }
   else if State<>clNone then State:=clNone;
 end;
procedure TClientLink.NetMessage(cmd:byte; var Data; DataSize:word);
 begin end;
function TClientLink.NetListen(var cmd:byte; var Buf:TNetBuf):boolean;
 begin end;
Procedure TClientLink.Registrate;
 begin
  State:=clRgst; CliNo:=Client;
  NetSend(ncIAmServer,IAmServer,SizeOf(IAmServer));
 end;
procedure TClientLink.NetSend(cmd:byte; var Data; DataSize:word);
 var Buf:TNetBuf absolute Data;
 begin
  if LogFileEnable then begin
   ShowDialog(' to_'+HexByte(CliNo),cmd,Buf);
  end;
  NetMessage(cmd,Data,DataSize);
 end;
procedure TClientLink.SendToAll(cmd:byte; var Data; DataSize:word);
 var P:PClientLink;
 begin
  P:=@Self;
  repeat
   with P^ do if State=clNorm then NetSend(cmd,Data,DataSize);
   P:=PClientLink(P^.Next);
  until P=@Self;
 end;

{----------------------------------------------------------------------}

procedure LogInit;
 begin
  if LogFileEnable then begin
   assign(LogFile,'SRDB.LOG'); Rewrite(LogFile);
   writeln(LogFile,'SRDB log file: contains full dialog');
   writeln(LogFile,'-----------------------------------');
  end;
  IAmServer.Name:='SRDB active server';
  IAmServer.FCnt:=FileCount;
  if LogFileEnable then begin
   writeln(LogFile,FileCount,' open files in database');
   writeln(LogFile,IAmServer.Name+' is ready ...');
   close(LogFile);
  end;
 end;

end.

