unit sr_net;
interface

{---------------------------------------------------------------------

(C) by Skelet (Georgi Georgiev) in terms of GNU General Public License

This program is a small netware server, derivative form n_echod3.
Must be compiled by fpk-pascal compiler, version 0.99.05 or later,
under Linux OS.

---------------------------------------------------------------------}

procedure RunDaemon;

implementation

uses netctrl, lists, Linux, sr_conn, sk_types, common, crt;

const
 Err_TryAgain = 11;
 Err_EBadF = 9;
 SO_ReUseAddr = 2;
 SOL_Socket = 1;
 NormalDelay = 20;
{
SelectDelay:longint = NormalDelay;
}

type
 PClient = ^TClient;
 TClient = object (TClientLink)
  constructor Init(aClient:longint);
  destructor Done; virtual;
  procedure NetMessage(cmd:byte; var Data; DataSize:word); virtual;
  function NetListen(var cmd:byte; var Buf:TNetBuf):boolean; virtual;
 end;
 TDaemon = object (TTail)
  connsocket:longint;
  ClientCnt:word; PassiveCnt:longint;
  constructor Init(MyPort:word; MaxClients:longint);
  procedure AcceptNew;
  procedure Run;
 end;

var
 Daemon:TDaemon;

procedure Error(s:string); begin writeln('NetError: ',s); halt end;

constructor TClient.Init(aClient:longint);
 begin
  inherited Init;
  writeln('Client ',aClient,' is ready to go ...');
  Client:=aClient; Connected:=True;
  Registrate;
 end;
destructor TClient.Done;
 begin
  { fdClose(Client); > other case to do the same }
  if 0>shutdown(Client,2)
   then Error('shutdown')
   else Writeln('Client ',Client,' was disconnected ...');
  inherited Done
 end;
procedure TClient.NetMessage(cmd:byte; var Data; DataSize:word);
 var P:PBlock;
 begin if Connected then begin
{  writeln('NetSend ',DataSize,' bytes, cmd=',cmd); }
  GetMem(P,DataSize+3);
  Move(DataSize,P^,SizeOf(word));
  Move(cmd,P^[2],1);
  Move(Data,P^[3],DataSize);
  fdWrite(Client,P^,DataSize+3);
  FreeMem(P,DataSize+3);
 end end;
function TClient.NetListen(var cmd:byte; var Buf:TNetBuf):boolean;
 var 
  DataSize:word; ActRd,LinErr:longint;
{ SetRd,SetWr,SetEx:fdSet;  } 
 begin
{
  FD_Zero(SetRd); FD_Set(Client,SetRd); 
  FD_Zero(SetWr);
  FD_Zero(SetEx);
  if Select(250,@SetRd,@SetWr,@SetEx,SelectDelay)>0 then begin
}  
  ActRd:=fdRead(Client,DataSize,2);
  if 2=ActRd then begin
   NetListen:=True;
   ActRd:=fdRead(Client,cmd,1);
   if ActRd<>1
    then Error('Cant read cmd')
    else begin
     ActRd:=fdRead(Client,Buf,DataSize);
     if ActRd<>DataSize then Error('Cant read Buf');
    end;
  end else begin
   NetListen:=false;
   if (ActRd<=0) { and (LinuxError<>Err_TryAgain) }
    then begin
     LinErr:=LinuxError;
     if LinErr<>Err_TryAgain then begin
      writeln(ActRd,'/',LinErr,
       ' error is detected while reading from the Net !');
      Connected:=false
     end;
    end
    else if ActRd=1 
     then Error('1 byte read from DataSize');
  end;
{
  end else NetListen:=False;
}
 end;

constructor TDaemon.Init(MyPort:word; MaxClients:longint);
 var SA_conn:TSockAddr_inet; ReUse:boolean;
 begin
  connsocket:=socket(AF_INET,SOCK_STREAM, 6 { 6 tcp; 0 ip generic });
  if connsocket<0 then Error('socket');
  ReUse:=True;
  if setsockopt(connsocket,SOL_Socket,SO_ReUseAddr,ReUse,1)<0
   then Error('setsockopt');
  if _fcntl(connsocket,F_SetFl,Open_NonBlock)=-1 then Error('fcntl');
  with SA_conn do begin
   Domain:=AF_INET; Port:=SwapWord(MyPort);
   inet_adr_to_Num('0.0.0.0' { wait from INADDR_ANY } ,Host); 
  end;
  if 0<>bind(connsocket,SA_conn,SizeOf(SA_conn)) then Error('bind');
  if 0<>listen(connsocket,MaxClients) then Error('bind');
  inherited Init;
  ClientCnt:=0; PassiveCnt:=0;
  writeln('Now i am listening for clients ...');
 end;
procedure TDaemon.AcceptNew;
 var 
  NewCli:longint; SA_client:TSockAddr_inet; SA_clilen:longint; 
  i:byte; ReUse:boolean;
 begin
  SA_clilen:=SizeOf(SA_client);
  NewCli:=accept(connsocket,SA_client,SA_clilen);
  if (NewCli<0) and (NetError<>Err_TryAgain)
   then Error('accept')
   else if NewCli>=0 then begin
    ReUse:=True;
    if setsockopt(NewCli,SOL_Socket,SO_ReUseAddr,@ReUse,1)<0
     then Error('setsockopt');
    { --- Fcntl is used here to unblock the new socket !!! --- }
    if _fcntl(NewCli,F_SetFl,Open_NonBlock)=-1 then Error('fcntl');
    writeln('Connection from IP ',inet_num_to_adr(SA_client.Host),
            '; Port: ',SwapWord(SA_client.Port));
    InsertNode(New(PClient,Init(NewCli)));
    Inc(ClientCnt); PassiveCnt:=0;
    writeln('ClientCnt now is ',ClientCnt);
   end else inc(PassiveCnt);
 end;
procedure TDaemon.Run;
 begin repeat
  if PassiveCnt>ClientCnt+5 then Delay(NormalDelay); 
  AcceptNew;
  if Cursor<>Nil then begin
   if PClient(Cursor)^.Talk
    then PassiveCnt:=0
    else inc(PassiveCnt);
   if not PClient(Cursor)^.Connected 
    then begin
     DeleteNode; 
     Dec(ClientCnt);
    end else RollNode;
  end;
 until false end;

procedure RunDaemon;
 begin
  Daemon.Init(ServerPort,MaxClients);
  Daemon.Run;
 end;

end.
